(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var ui             = require( './../libs/ui.js' );
var formHandler    = require( './../libs/form.js' );
var ipimprSearcher = require( './../dest/searcher.js' );
var ipimprEditor   = require( './../dest/editor.js' );

(function($)
{
  "use strict";

  $(document).ready(function()
  {
    //Prepare ui
    if (typeof ui_base_image != 'undefined') {
      ui.base.construct.prototype.image_base = ui_base_image;
    }
    ui.base.confirm.prototype.set_ajax = function( ajax_url )
    {
        this.ajax_url = ajax_url;
    };
    ui.init();

    //
    //Color picker
    //
    if ( $('.ipimpr-color-picker').length > 0 ) {
      $('.ipimpr-color-picker').each( function() {
        var picker = $(this);
        picker.wpColorPicker({
          change: function(event, ui){
            picker.val( ui.color.toString() );
          }
        });
      });
    }

    //
    //Main frame open
    $( '#ipimpr-media-button' ).click( function(e)
    {
      var popup = $( '#ipimpr-first-frame' );
      ui.modal.popup_show( popup );

      return false;
    });

    //
    //Media frame open
    var ipimprFrameMedia;
    var ipimprCanvasActive = false;
    $( '.ipimpr-first-do-gallery' ).click( function(e)
    {
      e.preventDefault();
      var button = $(this);

      //Hide first modal
      var popup = $( '#ipimpr-first-frame' );
      ui.modal.popup_hide( popup );

      // If the media frame already exists, reopen it.
      if ( ipimprFrameMedia ) {
        ipimprFrameMedia.open();
        return;
      }
      // Create the media frame.
      ipimprFrameMedia = wp.media.frames.ipimprMedia = wp.media(
      {
        // Set the title of the modal.
        title: button.data('choose'),

        // Tell the modal to show only images.
        library: {
          type: 'image'
        },

        // Customize the submit button.
        button: {
          // Set the text of the button.
          text: button.data('update'),
          // Tell the button not to close the modal, since we're
          // going to refresh the page when the image is selected.
          close: false
        }
      });

      // When an image is selected, run a callback.
      ipimprFrameMedia.on( 'select', function()
      {
        // Grab the selected attachment.
        var attachment = ipimprFrameMedia.state().get('selection').first();
        var id   = attachment.id;
        var url  = attachment.attributes.sizes.full.url;
        var img  = $( '#ipimpr-editor-image' );

        //img.attr( 'src', url );
        //Get image size
        var height = attachment.attributes.height;
        var width  = attachment.attributes.width;

        $( '#ipimpr-editor-save' ).attr( 'data-id', id );
        //set height & width
        $( '#__ipimpr-editor-resize-width' ).val( width );
        $( '#__ipimpr-editor-resize-height' ).val( height );

        //
        //Setup editor
        if ( ! ipimprCanvasActive ) {
          ipimprCanvasActive = ipimprEditor.init( attachment );
        } else {
          ipimprEditor.continue( attachment, ipimprCanvasActive );
        }

        ipimprFrameMedia.close();

        //
        //Open modal edit image
        var popup = $( '#ipimpr-editor-frame' );
        ui.modal.popup_show( popup );
      });

      ipimprFrameMedia.open();

    });

    //
    //Search frame open
    $( '.ipimpr-first-do-search' ).click( function(e)
    {
      e.preventDefault();
      var button = $(this);

      //Hide first modal
      var popup = $( '#ipimpr-first-frame' );
      ui.modal.popup_hide( popup );

      //Show search modal
      var popup = $( '#ipimpr-search-frame' );
      ui.modal.popup_show( popup );
    });

    //
    //Media frame close
    $( '.ipimpr-ui-close-link' ).click( function()
    {
      var popup = $(this).parents( '.ipimpr-ui-modal' );
      ui.modal.popup_hide( popup );
    });

    //
    //Do search stock image
    //
    $( '#ipimpr-search-keyword-button' ).click( function()
    {
      var keyword = $( '#ipimpr-search-keyword-input' ).val();
      //If keyword empty show alert
      if ( keyword == null || keyword == '' || keyword == ' ' )
      {
        ui.alert.show( 'You must enter the image keyword' );
        return false;
      }
      //
      //Disabled input
      $( '#ipimpr-search-keyword-input' )
        .addClass( '_disabled' )
        .attr( 'disabled', 'disabled' );
      $( this ).addClass( '_disabled' ).attr( 'disabled', 'disabled' );

      $( '.ipimpr-search-info ._result' ).hide();

      //Show loader
      //ui.loader.show();
      //Clear images
      $( '.ipimpr-search-results ._images' ).html('');
      //Run searcher
      ipimprSearcher.init( keyword );

      return false;
    });

    //
    //Do search filter
    //
    $( '#ipimpr-search-filter-button' ).click( function()
    {
      var provider = $( '#ipimpr-provider-input' ).val();
      if ( provider == 'all' )
      {
        $( '.ipimpr-search-results ._image' ).show();
      }
      else {
        $( '.ipimpr-search-results ._image' ).hide();
        $( '.ipimpr-search-results ._image-' + provider ).show();
      }
      return false;
    });

    //
    //Settings form handler
    var formSetting = new formHandler( '#ipimpr-form-setting' );
    formSetting.init();

    //
    //Action insert post from search
    $( '#ipimpr-search-insert' ).click( function()
    {
      //Show modal
      var popup = $( '#ipimpr-file-frame' );
      ui.modal.popup_show( popup );

      return false;
    });

    //Do insert action
    var ipimpr_photoOnProcess = false;
    $( '#ipimpr-do-insert-image' ).click( function()
    {
      var photoId    = $( '#ipimpr-photo-id-selected' ).val();
      var photoType  = $( '#ipimpr-photo-type-selected' ).val();
      var photoUrl   = $( '#ipimpr-photo-url-selected' ).val();
      var filename   = $( '#ipimpr-image-file-name' ).val();

      //Show loader
      ui.loader.show();

      var photoData = ipimprSearcher.currentPhoto;
      var ajaxData  = 'photo_id=' + photoId +
                      '&photo_url=' + photoUrl +
                      '&photo_type=' + photoType +
                      '&filename=' + filename +
                      '&title=' + $( '.ipimpr-image-detail ._detail-image-title' ).text() +
                      '&caption=' + $( '.ipimpr-image-detail ._detail-meta-caption' ).text() +
                      '&alt=' + $( '.ipimpr-image-detail ._detail-meta-alt' ).text() +
                      '&desc=' + $( '.ipimpr-image-detail ._detail-meta-desc' ).text();

      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=insertimage',
        type: "POST",
        data: ajaxData,
        dataType: "json",
        success: function ( result )
        {
          //Hide loader
          ui.loader.hide();
          //Show modal
          var popup = $( '#ipimpr-file-frame' );
          ui.modal.popup_hide( popup );
          var popup = $( '#ipimpr-search-frame' );
          ui.modal.popup_hide( popup );

          if ( result.status == 1 )
          {
            ipimpr_beforeInsertImagePost( result );
            
            //Show modal
            var popup = $( '#ipimpr-insert-frame' );
            ui.modal.popup_show( popup );
          }
          else
          {
            ui.message.modal( result.message, 'alert-danger' );
          }
        }
      });

      return false;
    });


    //Insert image from editor
    $( '#ipimpr-editor-insert' ).click( function()
    {
      //Show loader
      ui.loader.show();

      var button = $(this);
      var imgid  = button.data( 'id' );

      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=getimage',
        type: "POST",
        data: 'imageId=' + imgid,
        dataType: "json",
        success: function ( result )
        {
          //Hide loader
          ui.loader.hide();
          //Hide modal
          var popup = button.parents( '.ipimpr-ui-modal' );
          ui.modal.popup_hide( popup );

          if ( result.status == 1 )
          {
            ipimpr_beforeInsertImagePost( result );

            //Show modal
            var popup = $( '#ipimpr-insert-frame' );
            ui.modal.popup_show( popup );
          }
          else
          {
            ui.message.modal( result.message, 'alert-danger' );
          }
        }
      });

      return false;
    });

    function ipimpr_beforeInsertImagePost( result )
    {
      //Set id
      $( '.ipimpr-insert-main #ipimpr-attachment-id' ).val( result.data.id );
      //Set photo
      var src = result.data.sizes.thumbnail.url;
      $( '.ipimpr-insert-main ._detail-image-file' ).attr( 'src', src );
      //Set title
      $( '.ipimpr-insert-main ._detail-image-title' ).text( result.data.title );
      $( '.ipimpr-insert-main #ipimpr-image-content-title' ).val( result.data.title );
      //Set size
      var size = result.data.sizes.full.width + ' x ' + result.data.sizes.full.height;
      $( '.ipimpr-insert-main ._detail-image-size' ).text( size );
      //Set input caption
      $( '.ipimpr-insert-main #ipimpr-image-content-caption' ).val( result.data.caption );
      //Set input alt
      $( '.ipimpr-insert-main #ipimpr-image-content-alt' ).val( result.data.alt );
      //Set input desc
      $( '.ipimpr-insert-main #ipimpr-image-content-desc' ).val( result.data.description );
      //Set input sizes
      var select    = $( '.ipimpr-insert-main #ipimpr-image-display-size' );
      var sizes     = result.data.sizes;
      var thumbSize = sizes.thumbnail.width + ' x ' + sizes.thumbnail.height;
      select.append( '<option value="thumbnail">Thumbnail (' + thumbSize + ')</option>' );
      if ( typeof sizes.medium != 'undefined' ) {
        var medSize = sizes.medium.width + ' x ' + sizes.medium.height;
        select.append( '<option value="medium">Medium (' + medSize + ')</option>' );
      }
      if ( typeof sizes.large != 'undefined' ) {
        var larSize = sizes.large.width + ' x ' + sizes.large.height;
        select.append( '<option value="large">Large (' + larSize + ')</option>' );
      }
      select.append( '<option value="full">Full Size (' + size + ')</option>' );

      //Set input link to
      $( '.ipimpr-image-display-link-field' ).show();
      $( '#ipimpr-image-display-link' ).attr('readonly','readonly');
      $( '#ipimpr-image-display-link' ).val( result.data.url );

      ipimpr_photoOnProcess = result.data;
    }

    //
    //Action edit image from search
    $( '#ipimpr-search-save' ).click( function()
    {
      //Show modal
      var popup = $( '#ipimpr-file-edit-frame' );
      ui.modal.popup_show( popup );

      return false;
    });

    //Do save action
    $( '#ipimpr-do-search-edit-image' ).click( function()
    {
      var photoId    = $( '#ipimpr-photo-id-selected' ).val();
      var photoType  = $( '#ipimpr-photo-type-selected' ).val();
      var photoUrl   = $( '#ipimpr-photo-url-selected' ).val();
      var filename   = $( '#ipimpr-image-edit-file-name' ).val();

      //Show loader
      ui.loader.show();

      var photoData = ipimprSearcher.currentPhoto;
      var ajaxData  = 'photo_id=' + photoId +
                      '&photo_url=' + photoUrl +
                      '&photo_type=' + photoType +
                      '&filename=' + filename +
                      '&title=' + $( '.ipimpr-image-detail ._detail-image-title' ).text() +
                      '&caption=' + $( '.ipimpr-image-detail ._detail-meta-caption' ).text() +
                      '&alt=' + $( '.ipimpr-image-detail ._detail-meta-alt' ).text() +
                      '&desc=' + $( '.ipimpr-image-detail ._detail-meta-desc' ).text();

      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=insertimage',
        type: "POST",
        data: ajaxData,
        dataType: "json",
        success: function ( result )
        {
          //Hide loader
          ui.loader.hide();

          //Hide modal
          var popup = $( '#ipimpr-file-edit-frame' );
          ui.modal.popup_hide( popup );
          var popup = $( '#ipimpr-search-frame' );
          ui.modal.popup_hide( popup );

          if ( result.status == 1 )
          {
            var attachment = {};
            attachment.id  = result.data.id;
            attachment.attributes = result.data;

            var id   = attachment.id;
            var url  = attachment.attributes.sizes.full.url;
            var img  = $( '#ipimpr-editor-image' );

            //Get image size
            var height = attachment.attributes.height;
            var width  = attachment.attributes.width;

            $( '#ipimpr-editor-save' ).attr( 'data-id', id );
            //set height & width
            $( '#__ipimpr-editor-resize-width' ).val( width );
            $( '#__ipimpr-editor-resize-height' ).val( height );

            //
            //Setup editor
            if ( ! ipimprCanvasActive ) {
              ipimprCanvasActive = ipimprEditor.init( attachment );
            } else {
              ipimprEditor.continue( attachment, ipimprCanvasActive );
            }

            //
            //Open modal edit image
            var popup = $( '#ipimpr-editor-frame' );
            ui.modal.popup_show( popup );
          }
        }
      });

      return false;
    });

    //
    //Link To Change
    //
    $( '#ipimpr-image-display-link-to' ).change( function()
    {
      var value = $(this).val();
      if ( value == 'none' ) {
        $( '.ipimpr-image-display-link-field' ).hide();
      }
      else if ( value == 'custom' ) {
        $( '.ipimpr-image-display-link-field' ).show();
        $( '#ipimpr-image-display-link' ).removeAttr('readonly');
        $( '#ipimpr-image-display-link' ).val('http://');
      }
      else if ( value == 'file' ) {
        $( '.ipimpr-image-display-link-field' ).show();
        $( '#ipimpr-image-display-link' ).attr('readonly','readonly');
        $( '#ipimpr-image-display-link' ).val( ipimpr_photoOnProcess.url );
      }
      else if ( value == 'post' ) {
        $( '.ipimpr-image-display-link-field' ).show();
        $( '#ipimpr-image-display-link' ).attr('readonly','readonly');
        $( '#ipimpr-image-display-link' ).val( ipimpr_photoOnProcess.link );
      }
    });

    //
    //Insert form handler
    //
    $( '#ipimpr-do-insert-finish' ).click( function()
    {
      var title   = $( '#ipimpr-image-content-title' ).val();
      var caption = $( '#ipimpr-image-content-caption' ).val();
      var alt     = $( '#ipimpr-image-content-alt' ).val();
      var desc    = $( '#ipimpr-image-content-desc' ).val();
      var align   = $( '#ipimpr-image-display-align' ).val();
      var linkto  = $( '#ipimpr-image-display-link-to' ).val();
      var link    = $( '#ipimpr-image-display-link' ).val();
      var size    = $( '#ipimpr-image-display-size' ).val();
      var attId   = $( '#ipimpr-attachment-id' ).val();

      var ajaxData  = 'attachment_id=' + attId +
                      '&title=' + title +
                      '&caption=' + caption +
                      '&alt=' + alt +
                      '&description=' + desc;
      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=saveimagedata',
        type: "POST",
        data: ajaxData,
        dataType: "json",
        success: function ( result )
        {
        }
      });

      //Hide modal
      var popup = $( '#ipimpr-insert-frame' );
      ui.modal.popup_hide( popup );

      //Insert shortcode
      var sc = '<img class="align' + align + ' size-' + size + ' wp-image-' + attId + '"';
      sc += ' src="' + ipimpr_photoOnProcess['sizes'][size]['url'] + '"';
      sc += ' alt="' + alt + '"';
      sc += ' height="' + ipimpr_photoOnProcess['sizes'][size]['height'] + '"';
      sc += ' width="' + ipimpr_photoOnProcess['sizes'][size]['width'] + '"';
      sc += '/>';

      if ( linkto != 'none' )
      {
        var img = sc;
        sc  = '<a href="' + link + '"';
        sc += ' rel="attachment wp-att-' + attId + '">';
        sc += img;
        sc += '</a>';
      }

      if ( caption != '' )
      {
        var a = sc;
        sc  = '[caption id="attachment_' + attId + '"';
        sc += ' align="align' + align + '"';
        sc += ' width="' + ipimpr_photoOnProcess['sizes'][size]['width'] + '"]';
        sc += a;
        sc += caption;
        sc += '[/caption]';
      }

      var aed = tinyMCE.activeEditor;
      if ( aed ) {
        aed.selection.setContent( sc );
      }

      return false;
    });

  });

})(jQuery);

},{"./../dest/editor.js":5,"./../dest/searcher.js":6,"./../libs/form.js":7,"./../libs/ui.js":8}],2:[function(require,module,exports){
var ui = require( './../libs/ui.js' );

/*
 *===========================================================
 * Canvas text maniplation
 *===========================================================*/
var CanvasText;

(function($)
{
  //Prepare ui
  if (typeof ui_base_image != 'undefined') {
    ui.base.construct.prototype.image_base = ui_base_image;
  }
  ui.base.confirm.prototype.set_ajax = function( ajax_url )
  {
      this.ajax_url = ajax_url;
  };
  ui.init();

  CanvasText =
  {
    canvas:       null,
    image:        null,
    textLast:     false,

    text:         '',
    fontSize:     18,
    fontFamily:   'Times New Roman',
    fontWeight:   'normal',
    fontStyle:    'normal',
    color:        '#000000',
    top:          0,
    left:         0,

    //
    //Initialize
    init: function( canvas, image )
    {
      var $this   = this;
      this.canvas = canvas;
      this.image  = image;

      //
      //Action add text
      //
      $( '#__ipimpr-editor-text-submit' ).click( function()
      {
        //Show loader
        ui.loader.show();

        var text = $( '#__ipimpr-editor-text-value' ).val();
        if ( text == '' || text == ' ' )
        {
          ui.alert.show( 'You must enter the text' );
          return false;
        }
        $this.text = text;
        //
        //Set text properties
        $this.setProperties();

        //
        //Add text to canvas
        $this.addText();

        //Hide loader
        ui.loader.hide();

        return false;
      });

      //
      //Action edit text
      //
      $( '#__ipimpr-editor-text-edit-submit' ).click( function()
      {
        if ( ! $this.textLast ) {
          return false;
        }

        //Show loader
        ui.loader.show();

        var text = $( '#__ipimpr-editor-text-edit-value' ).val();
        if ( text == '' || text == ' ' )
        {
          ui.alert.show( 'You must enter the text' );
          return false;
        }
        $this.text = text;
        //
        //Set text properties
        $this.setEditProperties();
        //
        //Add text to canvas
        $this.updateText();

        //Hide loader
        ui.loader.hide();

        return false;
      });

      //
      //Action remove text
      //
      $( '#__ipimpr-editor-text-remove-submit' ).click( function()
      {
        if ( ! $this.textLast ) {
          return false;
        }

        //Show loader
        ui.loader.show();

        $this.canvas.remove( $this.textLast );

        //Hide loader
        ui.loader.hide();

        return false;
      });

      //
      //Add event
      $this.canvas.on('object:selected', this.onObjectSelected.bind(this));
      $this.canvas.on('object:moving', this.onObjectMoving.bind(this));
      $this.canvas.on('selection:cleared', this.onSelectionCleared.bind(this));
    },

    //
    //Add text
    addText: function()
    {
      var canvasTop  = this.image.getTop();
      var canvasLeft = this.image.getLeft();

      var textTop    = canvasTop + this.top;
      var textLeft   = canvasLeft + this.left;

      var textArgs = {
        top: textTop,
        left: textLeft,
        fontFamily: this.fontFamily,
        fontSize: this.fontSize,
        fontWeight: this.fontWeight,
        fontStyle: this.fontStyle,
        fill: this.color,
        lockScalingX: true,
        lockScalingY: true
      };

      var objText = new fabric.Text( this.text, textArgs );
      this.canvas.sendToBack( this.image );
      this.canvas.add( objText );
      this.canvas.bringToFront( objText );
      this.canvas.renderAll();

      $( '#camanjs-target' ).remove();
      var hiddenImg = document.createElement('img');
      hiddenImg.src = this.canvas.toDataURL();
      hiddenImg.id = 'camanjs-target';
      hiddenImg.style.display = 'none';
      document.body.appendChild(hiddenImg);

      //Clear inputs
      this.clearInputs();

    },

    //
    //Update text
    updateText: function()
    {
      if ( ! this.textLast ) {
        return false;
      }

      var canvasTop  = this.image.getTop();
      var canvasLeft = this.image.getLeft();

      var textTop    = canvasTop + this.top;
      var textLeft   = canvasLeft + this.left;

      var textArgs = {
        top: textTop,
        left: textLeft,
        fontFamily: this.fontFamily,
        fontSize: this.fontSize,
        fontWeight: this.fontWeight,
        fontStyle: this.fontStyle,
        fill: this.color
      };

      this.textLast.setText( this.text );
      this.textLast.setOptions( textArgs );
      this.canvas.renderAll();

    },

    //
    //on Object Selected
    onObjectSelected: function(event)
    {
      var currentText = event.target;

      if ( currentText.type != 'text' ) {
        return;
      }
      this.textLast = currentText;

      $( '.ipimpr-editor-actions ._actions-content' ).show();
      $( '.ipimpr-editor-actions ._action-content' ).hide();
      $( '#ipimpr-editor-action-text-edit' ).show();

      //Set value
      $( '#__ipimpr-editor-text-edit-value' ).val( currentText.text );
      $( '#__ipimpr-editor-text-edit-font-size' ).val( currentText.fontSize );
      $( '#__ipimpr-editor-text-edit-font-family' ).val( currentText.fontFamily );
      $( '#__ipimpr-editor-text-edit-top' ).val( currentText.top );
      $( '#__ipimpr-editor-text-edit-left' ).val( currentText.left );
      //Color
      $( '#__ipimpr-editor-text-edit-color' ).val( currentText.fill );
      $( '#__ipimpr-editor-text-edit-color' ).wpColorPicker( 'color', currentText.fill );

      if ( currentText.fontWeight == 'bold' ) {
        $( '#__ipimpr-editor-text-edit-font-weight' ).attr( 'checked', true );
      }
      if ( currentText.fontStyle == 'italic' ) {
        $( '#__ipimpr-editor-text-edit-font-italic' ).attr( 'checked', true );
      }
    },

    //
    //on Object Moving
    onObjectMoving: function(event)
    {
      var currentText = event.target;
      if ( currentText.type != 'text' ) {
        return;
      }

      var textTop  = currentText.getTop();
      var textLeft = currentText.getLeft();

      //Set top & left
      $( '#__ipimpr-editor-text-edit-top' ).val( textTop );
      $( '#__ipimpr-editor-text-edit-left' ).val( textLeft );
    },

    //
    //on selection cleared
    onSelectionCleared: function(event)
    {
      if ( this.textLast )
      {
        $( '.ipimpr-editor-actions ._actions-content' ).show();
        $( '.ipimpr-editor-actions ._action-content' ).hide();
        $( '#ipimpr-editor-action-text' ).show();

        $( '#__ipimpr-editor-text-edit-value' ).val( '' );
        $( '#__ipimpr-editor-text-edit-font-size' ).val( '' );
        $( '#__ipimpr-editor-text-edit-top' ).val( '' );
        $( '#__ipimpr-editor-text-edit-left' ).val( '' );
        $( '#__ipimpr-editor-text-edit-color' ).val( '' );

        this.textLast = false;
      }
    },

    //
    //Set text properties
    setProperties: function()
    {
      var fontsz = $( '#__ipimpr-editor-text-font-size' ).val();
      var fontf  = $( '#__ipimpr-editor-text-font-family' ).val();
      var weight = $( '#__ipimpr-editor-text-font-weight' ).is(':checked');
      var style  = $( '#__ipimpr-editor-text-font-italic' ).is(':checked');
      var top    = $( '#__ipimpr-editor-text-top' ).val();
      var left   = $( '#__ipimpr-editor-text-left' ).val();
      var color  = $( '#__ipimpr-editor-text-color' ).val();

      if ( fontsz != 0 && fontsz != '' && fontsz != ' ' ) {
        this.fontSize = fontsz;
      }
      if ( fontf != '' && fontf != ' ' ) {
        this.fontFamily = fontf;
      }
      if ( top != '' && top != ' ' ) {
        this.top = new Number( top );
      }
      if ( left != '' && left != ' ' ) {
        this.left = new Number( left );
      }
      if ( color != '' && color != ' ' ) {
        this.color = color;
      }

      if ( weight ) {
        this.fontWeight = 'bold';
      } else {
        this.fontWeight = 'normal';
      }
      if ( style ) {
        this.fontStyle = 'italic';
      } else {
        this.fontStyle = 'normal';
      }

    },

    //
    //Set text properties
    setEditProperties: function()
    {
      var fontsz = $( '#__ipimpr-editor-text-edit-font-size' ).val();
      var fontf  = $( '#__ipimpr-editor-text-edit-font-family' ).val();
      var weight = $( '#__ipimpr-editor-text-edit-font-weight' ).is(':checked');
      var style  = $( '#__ipimpr-editor-text-edit-font-italic' ).is(':checked');
      var top    = $( '#__ipimpr-editor-text-edit-top' ).val();
      var left   = $( '#__ipimpr-editor-text-edit-left' ).val();
      var color  = $( '#__ipimpr-editor-text-edit-color' ).val();

      if ( fontsz != 0 && fontsz != '' && fontsz != ' ' ) {
        this.fontSize = fontsz;
      }
      if ( fontf != '' && fontf != ' ' ) {
        this.fontFamily = fontf;
      }
      if ( top != '' && top != ' ' ) {
        this.top = new Number( top );
      }
      if ( left != '' && left != ' ' ) {
        this.left = new Number( left );
      }
      if ( color != '' && color != ' ' ) {
        this.color = color;
      }

      if ( weight ) {
        this.fontWeight = 'bold';
      } else {
        this.fontWeight = 'normal';
      }
      if ( style ) {
        this.fontStyle = 'italic';
      } else {
        this.fontStyle = 'normal';
      }

    },

    //
    //Clear inputs
    clearInputs: function()
    {
      $( '#__ipimpr-editor-text-value' ).val( '' );
      $( '#__ipimpr-editor-text-font-size' ).val( '' );
      $( '#__ipimpr-editor-text-top' ).val( '' );
      $( '#__ipimpr-editor-text-left' ).val( '' );
      $( '#__ipimpr-editor-text-color' ).val( '' );
    },
  }
})
(jQuery);

module.exports = CanvasText;

},{"./../libs/ui.js":8}],3:[function(require,module,exports){
/*
 *===========================================================
 * CropZone
 *===========================================================*/
var CropZone;

(function($)
{
  CropZone = fabric.util.createClass(fabric.Rect,
  {
    _render: function(ctx) {
      this.callSuper('_render', ctx);

      var canvas = ctx.canvas;
      var dashWidth = 7;

      // Set original scale
      var flipX = this.flipX ? -1 : 1;
      var flipY = this.flipY ? -1 : 1;
      var scaleX = flipX / this.scaleX;
      var scaleY = flipY / this.scaleY;

      ctx.scale(scaleX, scaleY);

      // Overlay rendering
      ctx.fillStyle = 'rgba(0, 0, 0, 0.5)';
      this._renderOverlay(ctx);

      // Set dashed borders
      if (ctx.setLineDash !== undefined)
        ctx.setLineDash([dashWidth, dashWidth]);
      else if (ctx.mozDash !== undefined)
        ctx.mozDash = [dashWidth, dashWidth];

      // First lines rendering with black
      ctx.strokeStyle = 'rgba(0, 0, 0, 0.2)';
      this._renderBorders(ctx);
      this._renderGrid(ctx);

      // Re render lines in white
      ctx.lineDashOffset = dashWidth;
      ctx.strokeStyle = 'rgba(255, 255, 255, 0.4)';
      this._renderBorders(ctx);
      this._renderGrid(ctx);

      // Reset scale
      ctx.scale(1/scaleX, 1/scaleY);
    },

    _renderOverlay: function(ctx) {
      var canvas = ctx.canvas;

      //
      //    x0    x1        x2      x3
      // y0 +------------------------+
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      // y1 +------+---------+-------+
      //    |\\\\\\|         |\\\\\\\|
      //    |\\\\\\|    0    |\\\\\\\|
      //    |\\\\\\|         |\\\\\\\|
      // y2 +------+---------+-------+
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      // y3 +------------------------+
      //

      var x0 = Math.ceil(-this.getWidth() / 2 - this.getLeft());
      var x1 = Math.ceil(-this.getWidth() / 2);
      var x2 = Math.ceil(this.getWidth() / 2);
      var x3 = Math.ceil(this.getWidth() / 2 + (canvas.width - this.getWidth() - this.getLeft()));

      var y0 = Math.ceil(-this.getHeight() / 2 - this.getTop());
      var y1 = Math.ceil(-this.getHeight() / 2);
      var y2 = Math.ceil(this.getHeight() / 2);
      var y3 = Math.ceil(this.getHeight() / 2 + (canvas.height - this.getHeight() - this.getTop()));

      ctx.beginPath();

      // Draw outer rectangle.
      // Numbers are +/-1 so that overlay edges don't get blurry.
      ctx.moveTo(x0 - 1, y0 - 1);
      ctx.lineTo(x3 + 1, y0 - 1);
      ctx.lineTo(x3 + 1, y3 + 1);
      ctx.lineTo(x0 - 1, y3 - 1);
      ctx.lineTo(x0 - 1, y0 - 1);
      ctx.closePath();

      // Draw inner rectangle.
      ctx.moveTo(x1, y1);
      ctx.lineTo(x1, y2);
      ctx.lineTo(x2, y2);
      ctx.lineTo(x2, y1);
      ctx.lineTo(x1, y1);

      ctx.closePath();
      ctx.fill();
    },

    _renderBorders: function(ctx) {
      ctx.beginPath();
      ctx.moveTo(-this.getWidth()/2, -this.getHeight()/2); // upper left
      ctx.lineTo(this.getWidth()/2, -this.getHeight()/2); // upper right
      ctx.lineTo(this.getWidth()/2, this.getHeight()/2); // down right
      ctx.lineTo(-this.getWidth()/2, this.getHeight()/2); // down left
      ctx.lineTo(-this.getWidth()/2, -this.getHeight()/2); // upper left
      ctx.stroke();
    },

    _renderGrid: function(ctx) {
      // Vertical lines
      ctx.beginPath();
      ctx.moveTo(-this.getWidth()/2 + 1/3 * this.getWidth(), -this.getHeight()/2);
      ctx.lineTo(-this.getWidth()/2 + 1/3 * this.getWidth(), this.getHeight()/2);
      ctx.stroke();
      ctx.beginPath();
      ctx.moveTo(-this.getWidth()/2 + 2/3 * this.getWidth(), -this.getHeight()/2);
      ctx.lineTo(-this.getWidth()/2 + 2/3 * this.getWidth(), this.getHeight()/2);
      ctx.stroke();
      // Horizontal lines
      ctx.beginPath();
      ctx.moveTo(-this.getWidth()/2, -this.getHeight()/2 + 1/3 * this.getHeight());
      ctx.lineTo(this.getWidth()/2, -this.getHeight()/2 + 1/3 * this.getHeight());
      ctx.stroke();
      ctx.beginPath();
      ctx.moveTo(-this.getWidth()/2, -this.getHeight()/2 + 2/3 * this.getHeight());
      ctx.lineTo(this.getWidth()/2, -this.getHeight()/2 + 2/3 * this.getHeight());
      ctx.stroke();
    }
  });
})
(jQuery);

module.exports = CropZone;

},{}],4:[function(require,module,exports){
var CropZone  = require( './../dest/crop-zone.js' );

/*
 *===========================================================
 * Crop
 *===========================================================*/
var Crop;

(function($)
{
  Crop =
  {
    canvas:   null,
    image:    null,

    // Init point
    startX: null,
    startY: null,

    // Keycrop
    isKeyCroping: false,
    isKeyLeft: false,
    isKeyUp: false,

    options: {
      // min crop dimension
      minHeight: 1,
      minWidth: 1,
      // ensure crop ratio
      ratio: null,
      // quick crop feature (set a key code to enable it)
      quickCropKey: false
    },

    //Initialize crop
    init: function( canvas, image )
    {
      var $this = this;

      this.canvas = canvas;
      this.image  = image;

      // Canvas events
      this.image.set({
        top: 0,
        left: 0,
        lockMovementX: true,
        lockMovementY: true,
        hoverCursor: 'crosshair'
      });
      this.canvas.on('mouse:down', this.onMouseDown.bind(this));
      this.canvas.on('mouse:move', this.onMouseMove.bind(this));
      this.canvas.on('mouse:up', this.onMouseUp.bind(this));
      this.canvas.on('object:moving', this.onObjectMoving.bind(this));
      this.canvas.on('object:scaling', this.onObjectScaling.bind(this));

      fabric.util.addListener(fabric.document, 'keydown', this.onKeyDown.bind(this));
      fabric.util.addListener(fabric.document, 'keyup', this.onKeyUp.bind(this));

      this.toggleCrop();

      //
      //Cancel cropping
      $( '#__ipimpr-editor-crop-cancel' ).click( function()
      {
        $this.releaseFocus();
        return false;
      });
      //
      //Do cropping
      $( '#__ipimpr-editor-crop-submit' ).click( function()
      {
        $this.doCropping();
        return false;
      });
    },

    // Avoid crop zone to go beyond the canvas edges
    onObjectMoving: function(event)
    {
      if (!this.hasFocus()) {
        return;
      }

      var currentObject = event.target;
      if (currentObject !== this.cropZone)
        return;

      var canvas = this.canvas;
      var x = currentObject.getLeft(), y = currentObject.getTop();
      var w = currentObject.getWidth(), h = currentObject.getHeight();
      var maxX = canvas.getWidth() - w;
      var maxY = canvas.getHeight() - h;

      if (x < 0)
        currentObject.set('left', 0);
      if (y < 0)
        currentObject.set('top', 0);
      if (x > maxX)
        currentObject.set('left', maxX);
      if (y > maxY)
        currentObject.set('top', maxY);
    },

    // Prevent crop zone from going beyond the canvas edges (like mouseMove)
    onObjectScaling: function(event)
    {
      if (!this.hasFocus()) {
        return;
      }

      var preventScaling = false;
      var currentObject = event.target;
      if (currentObject !== this.cropZone)
        return;

      var canvas = this.canvas;
      var pointer = canvas.getPointer(event.e);
      var x = pointer.x;
      var y = pointer.y;

      var minX = currentObject.getLeft();
      var minY = currentObject.getTop();
      var maxX = currentObject.getLeft() + currentObject.getWidth();
      var maxY = currentObject.getTop() + currentObject.getHeight();

      if (null !== this.options.ratio) {
        if (minX < 0 || maxX > canvas.getWidth() || minY < 0 || maxY > canvas.getHeight()) {
          preventScaling = true;
        }
      }

      if (minX < 0 || maxX > canvas.getWidth() || preventScaling) {
        var lastScaleX = this.lastScaleX || 1;
        currentObject.setScaleX(lastScaleX);
      }
      if (minX < 0) {
        currentObject.setLeft(0);
      }

      if (minY < 0 || maxY > canvas.getHeight() || preventScaling) {
        var lastScaleY = this.lastScaleY || 1;
        currentObject.setScaleY(lastScaleY);
      }
      if (minY < 0) {
        currentObject.setTop(0);
      }

      if (currentObject.getWidth() < this.options.minWidth) {
        currentObject.scaleToWidth(this.options.minWidth);
      }
      if (currentObject.getHeight() < this.options.minHeight) {
        currentObject.scaleToHeight(this.options.minHeight);
      }

      this.lastScaleX = currentObject.getScaleX();
      this.lastScaleY = currentObject.getScaleY();
    },

    // Init crop zone
    onMouseDown: function(event)
    {
      if (!this.hasFocus()) {
        return;
      }

      var canvas = this.canvas;

      // recalculate offset, in case canvas was manipulated since last `calcOffset`
      canvas.calcOffset();
      var pointer = canvas.getPointer(event.e);
      var x = pointer.x;
      var y = pointer.y;
      var point = new fabric.Point(x, y);

      // Check if user want to scale or drag the crop zone.
      var activeObject = canvas.getActiveObject();
      if (activeObject === this.cropZone || this.cropZone.containsPoint(point)) {
        return;
      }

      canvas.discardActiveObject();
      this.cropZone.setWidth(0);
      this.cropZone.setHeight(0);
      this.cropZone.setScaleX(1);
      this.cropZone.setScaleY(1);

      this.startX = x;
      this.startY = y;
    },

    // Extend crop zone
    onMouseMove: function(event)
    {
      // Quick crop feature
      if (this.isKeyCroping)
        return this.onMouseMoveKeyCrop(event);

      if (null === this.startX || null === this.startY) {
        return;
      }

      var canvas = this.canvas;
      var pointer = canvas.getPointer(event.e);
      var x = pointer.x;
      var y = pointer.y;

      this._renderCropZone(this.startX, this.startY, x, y);
    },

    onMouseMoveKeyCrop: function(event)
    {
      var canvas = this.canvas;
      var zone   = this.cropZone;

      var pointer = canvas.getPointer(event.e);
      var x = pointer.x;
      var y = pointer.y;

      if (!zone.left || !zone.top) {
        zone.setTop(y);
        zone.setLeft(x);
      }

      this.isKeyLeft =  x < zone.left + zone.width / 2 ;
      this.isKeyUp = y < zone.top + zone.height / 2 ;

      this._renderCropZone(
        Math.min(zone.left, x),
        Math.min(zone.top, y),
        Math.max(zone.left+zone.width, x),
        Math.max(zone.top+zone.height, y)
      );
    },

    // Finish crop zone
    onMouseUp: function(event)
    {
      if (null === this.startX || null === this.startY) {
        return;
      }

      var canvas = this.canvas;
      this.cropZone.setCoords();
      canvas.setActiveObject(this.cropZone);
      canvas.calcOffset();

      this.startX = null;
      this.startY = null;
    },

    onKeyDown: function(event)
    {
      if (false === this.options.quickCropKey || event.keyCode !== this.options.quickCropKey || this.isKeyCroping)
        return;

      // Active quick crop flow
      this.isKeyCroping = true ;
      this.canvas.discardActiveObject();
      this.cropZone.setWidth(0);
      this.cropZone.setHeight(0);
      this.cropZone.setScaleX(1);
      this.cropZone.setScaleY(1);
      this.cropZone.setTop(0);
      this.cropZone.setLeft(0);
    },

    onKeyUp: function(event)
    {
      if (false === this.options.quickCropKey || event.keyCode !== this.options.quickCropKey || !this.isKeyCroping)
        return;

      // Unactive quick crop flow
      this.isKeyCroping = false;
      this.startX = 1;
      this.startY = 1;
      this.onMouseUp();
    },

    selectZone: function(x, y, width, height, forceDimension)
    {
      if (!this.hasFocus())
        this.requireFocus();

      if (!forceDimension) {
        this._renderCropZone(x, y, x+width, y+height);
      } else {
        this.cropZone.set({
          'left': x,
          'top': y,
          'width': width,
          'height': height
        });
      }

      var canvas = this.canvas;
      canvas.bringToFront(this.cropZone);
      this.cropZone.setCoords();
      canvas.setActiveObject(this.cropZone);
      canvas.calcOffset();
    },

    toggleCrop: function()
    {
      if (!this.hasFocus())
        this.requireFocus();
      else
        this.releaseFocus();
    },

    cropCurrentZone: function()
    {
      if (!this.hasFocus())
        return;

      // Avoid croping empty zone
      if (this.cropZone.width < 1 && this.cropZone.height < 1)
        return;

      var image = this.image;

      // Compute crop zone dimensions
      var top = this.cropZone.getTop() - image.getTop();
      var left = this.cropZone.getLeft() - image.getLeft();
      var width = this.cropZone.getWidth();
      var height = this.cropZone.getHeight();

      // Adjust dimensions to image only
      if (top < 0) {
        height += top;
        top = 0;
      }

      if (left < 0) {
        width += left;
        left = 0;
      }
    },

    // Test wether crop zone is set
    hasFocus: function() {
      return this.cropZone !== undefined;
    },

    // Create the crop zone
    requireFocus: function() {
      this.cropZone = new CropZone({
        fill: 'transparent',
        hasBorders: false,
        originX: 'left',
        originY: 'top',
        //stroke: '#444',
        //strokeDashArray: [5, 5],
        //borderColor: '#444',
        cornerColor: '#444',
        cornerSize: 8,
        transparentCorners: false,
        lockRotation: true,
        hasRotatingPoint: false,
      });

      if (null !== this.options.ratio) {
        this.cropZone.set('lockUniScaling', true);
      }

      this.canvas.add(this.cropZone);
      this.canvas.defaultCursor = 'crosshair';
    },

    // Remove the crop zone
    releaseFocus: function()
    {
      if (undefined === this.cropZone)
        return;

      this.cropZone.remove();
      this.cropZone = undefined;

      this.canvas.defaultCursor = 'default';

      this.image.set({
        lockMovementX: false,
        lockMovementY: false,
        hoverCursor: 'move'
      });

      $( '.ipimpr-editor-actions ._actions-menu ._action-link' ).removeClass( '_active' );
      $( '.ipimpr-editor-actions ._actions-menu li:first-child ._action-link' ).addClass( '_active' );
      $( '.ipimpr-editor-actions ._action-content' ).hide();
      $( '#ipimpr-editor-action-resize' ).show();
    },

    _renderCropZone: function(fromX, fromY, toX, toY)
    {
      var canvas = this.canvas;

      var isRight = (toX > fromX);
      var isLeft = !isRight;
      var isDown = (toY > fromY);
      var isUp = !isDown;

      var minWidth = Math.min(+this.options.minWidth, canvas.getWidth());
      var minHeight = Math.min(+this.options.minHeight, canvas.getHeight());

      // Define corner coordinates
      var leftX = Math.min(fromX, toX);
      var rightX = Math.max(fromX, toX);
      var topY = Math.min(fromY, toY);
      var bottomY = Math.max(fromY, toY);

      // Replace current point into the canvas
      leftX = Math.max(0, leftX);
      rightX = Math.min(canvas.getWidth(), rightX);
      topY = Math.max(0, topY)
      bottomY = Math.min(canvas.getHeight(), bottomY);

      // Recalibrate coordinates according to given options
      if (rightX - leftX < minWidth) {
        if (isRight)
          rightX = leftX + minWidth;
        else
          leftX = rightX - minWidth;
      }
      if (bottomY - topY < minHeight) {
        if (isDown)
          bottomY = topY + minHeight;
        else
          topY = bottomY - minHeight;
      }

      // Truncate truncate according to canvas dimensions
      if (leftX < 0) {
        // Translate to the left
        rightX += Math.abs(leftX);
        leftX = 0
      }
      if (rightX > canvas.getWidth()) {
        // Translate to the right
        leftX -= (rightX - canvas.getWidth());
        rightX = canvas.getWidth();
      }
      if (topY < 0) {
        // Translate to the bottom
        bottomY += Math.abs(topY);
        topY = 0
      }
      if (bottomY > canvas.getHeight()) {
        // Translate to the right
        topY -= (bottomY - canvas.getHeight());
        bottomY = canvas.getHeight();
      }

      var width = rightX - leftX;
      var height = bottomY - topY;
      var currentRatio = width / height;

      if (this.options.ratio && +this.options.ratio !== currentRatio) {
        var ratio = +this.options.ratio;

        if(this.isKeyCroping) {
          isLeft = this.isKeyLeft;
          isUp = this.isKeyUp;
        }

        if (currentRatio < ratio) {
          var newWidth = height * ratio;
          if (isLeft) {
            leftX -= (newWidth - width);
          }
          width = newWidth;
        } else if (currentRatio > ratio) {
          var newHeight = height / (ratio * height/width);
          if (isUp) {
            topY -= (newHeight - height);
          }
          height = newHeight;
        }

        if (leftX < 0) {
          leftX = 0;
          //TODO
        }
        if (topY < 0) {
          topY = 0;
          //TODO
        }
        if (leftX + width > canvas.getWidth()) {
          var newWidth = canvas.getWidth() - leftX;
          height = newWidth * height / width;
          width = newWidth;
          if (isUp) {
            topY = fromY - height;
          }
        }
        if (topY + height > canvas.getHeight()) {
          var newHeight = canvas.getHeight() - topY;
          width = width * newHeight / height;
          height = newHeight;
          if (isLeft) {
            leftX = fromX - width;
          }
        }
      }

      // Apply coordinates
      this.cropZone.left = leftX;
      this.cropZone.top = topY;
      this.cropZone.width = width;
      this.cropZone.height = height;

      this.canvas.bringToFront(this.cropZone);
    },

    //
    //Do cropping image
    //
    doCropping: function()
    {
      var $this  = this;
      var canvas = this.canvas;

      if (undefined === this.cropZone)
        return false;

      var left   = this.cropZone.left;
      var top    = this.cropZone.top;
      var width  = this.cropZone.width;
      var height = this.cropZone.height;

      Caman( "#camanjs-target", function ()
      {
        var newcanvas = document.createElement('canvas');
        newcanvas.id = 'camanjs-target';
        newcanvas.style.display = 'none';
        newcanvas.width = width;
        newcanvas.height = height;
        // Get the new context and draw a portion of the current canvas
        // to the new canvas.
        var ctx = newcanvas.getContext('2d');
        ctx.drawImage(this.canvas, left, top, width, height, 0, 0, width, height);

        // Tell CamanJS to replace the current canvas with our new cropped one.
        this.replaceCanvas(newcanvas);

        var camanObj = document.getElementById( 'camanjs-target' );
        $this.image.setSrc( camanObj.toDataURL(), function() {
          $this.canvas.renderAll();
        });

        $this.releaseFocus();
      });
    }
  };
})
(jQuery);

module.exports = Crop;

},{"./../dest/crop-zone.js":3}],5:[function(require,module,exports){
var ui          = require( './../libs/ui.js' );
var Crop        = require( './../dest/crop.js' );
var CanvasText  = require( './../dest/canvas-text.js' );

/*
 *===========================================================
 * Image editor
 *===========================================================*/
var ipimprEditor;

(function($)
{
  //Prepare ui
  if (typeof ui_base_image != 'undefined') {
    ui.base.construct.prototype.image_base = ui_base_image;
  }
  ui.base.confirm.prototype.set_ajax = function( ajax_url )
  {
      this.ajax_url = ajax_url;
  };
  ui.init();

  ipimprEditor =
  {
    attachment: false,
    canvasId: 'ipimpr-editor-canvas',
    canvas: null,
    fbrImage: null,
    imageWidth: 0,
    imageHeight: 0,

    init: function( attachment )
    {
      var $this = this;
      $this.attachment = attachment;
      var imgsrc = attachment.attributes.sizes.full.url;

      //set width & height
      $this.imageWidth  = attachment.attributes.width;
      $this.imageHeight = attachment.attributes.height;

      var canvas  = new fabric.Canvas( this.canvasId );
      $this.canvas = canvas;
      //remove image
      if ( $this.fbrImage ) {
        canvas.remove( $this.fbrImage );
        $this.fbrImage = null;
      }

      //reset button
      $( '.ipimpr-editor-tool' ).removeClass( 'disabled' );
      $( '.ipimpr-editor-tool' ).removeAttr( 'disabled' );
      $( '.ipimpr-editor-filter' ).removeClass( 'disabled' );
      $( '.ipimpr-editor-filter' ).removeAttr( 'disabled' );

      fabric.Image.fromURL(imgsrc, function(img)
      {
        $this.fbrImage = img;
        img.set({
          left: 20,
          top: 20,
          height: attachment.attributes.height,
          width: attachment.attributes.width,
          lockRotation: true,
          lockScalingFlip: true,
          lockScalingX: true,
          lockScalingY: true,
        });

        canvas.add(img).setActiveObject(img);
        canvas.renderAll();

        var hiddenImg = document.createElement('img');
        hiddenImg.src = canvas.getActiveObject().toDataURL();
        hiddenImg.id = 'camanjs-target';
        hiddenImg.style.display = 'none';
        document.body.appendChild(hiddenImg);

        //
        //Prepare camanjs
        //
        Caman.Filter.register('oldpaper', function()
        {
          this.pinhole();
          this.noise(10);
          this.orangePeel();
          this.render();
        });
        Caman.Filter.register("pleasant", function() {
          this.colorize(60, 105, 218, 10);
          this.contrast(10);
          this.sunrise();
          this.hazyDays();
          this.render();
        });
        Caman.Filter.register('greentint', function()
        {
          this.brightness(-10);

          this.newLayer(function() {
            this.setBlendingMode("overlay");
            this.opacity(100);
            this.fillColor('#689900');
            this.filter.brightness(15);
            this.filter.contrast(10);
          });

          this.render();
        });

        Caman( '#camanjs-target', function()
        {
          this.render();
        });

        //Tools
        $this.tools();
        //Filters
        $this.filters();
        //Actions
        $this.actions();
      },
      { crossOrigin: 'anonymous' });

      return canvas;

    },

    continue: function( attachment, canvas )
    {
      var $this = this;
      $this.attachment = attachment;
      var imgsrc = attachment.attributes.sizes.full.url;

      //set width & height
      $this.imageWidth  = attachment.attributes.width;
      $this.imageHeight = attachment.attributes.height;

      $this.canvas = canvas;
      //remove image
      if ( $this.fbrImage ) {
        canvas.remove( $this.fbrImage );
        $this.fbrImage = null;
        $( '#camanjs-target' ).remove();
      }

      //reset button
      $( '.ipimpr-editor-tool' ).removeClass( 'disabled' );
      $( '.ipimpr-editor-tool' ).removeAttr( 'disabled' );
      $( '.ipimpr-editor-filter' ).removeClass( 'disabled' );
      $( '.ipimpr-editor-filter' ).removeAttr( 'disabled' );

      fabric.Image.fromURL(imgsrc, function(img)
      {
        $this.fbrImage = img;
        img.set({
          left: 20,
          top: 20,
          height: attachment.attributes.height,
          width: attachment.attributes.width,
          lockRotation: true,
          lockScalingFlip: true,
          lockScalingX: true,
          lockScalingY: true,
          hasBorders: false,
          hasRotatingPoint: false,
          hoverCursor: 'move'
        });

        canvas.add(img).setActiveObject(img);
        canvas.renderAll();

        var hiddenImg = document.createElement('img');
        hiddenImg.src = canvas.getActiveObject().toDataURL();
        hiddenImg.id = 'camanjs-target';
        hiddenImg.style.display = 'none';
        document.body.appendChild(hiddenImg);

        Caman( '#camanjs-target', function()
        {
          this.render();
        });
      },
      { crossOrigin: 'anonymous' });

    },

    //Image tools
    tools: function()
    {
      var $this = this;

      $( '.ipimpr-editor-tool' ).each( function()
      {
        var button = $(this);
        button.click( function(e)
        {
          e.preventDefault();

          //Show loader
          ui.loader.show();
          //Disabled button
          button.addClass( 'disabled' );
          button.attr( 'disabled', 'disabled' );

          var tool  = button.data( 'tool' );
          var value = parseInt( button.data( 'value' ) );

          Caman( '#camanjs-target', function()
          {
            var camanObj = document.getElementById( 'camanjs-target' );

            // If such an effect exists, use it:
            if( tool in this)
            {
              this[tool](value);
              this.render(function()
              {
                $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
                  $this.canvas.renderAll();
                });

                //Hide loader
                ui.loader.hide();
                //Undisabled button
                button.removeClass( 'disabled' );
                button.removeAttr( 'disabled' );
              });
            }
          });
          return false;
        });
      });

      //
      //Btn reset image
      $( '.ipimpr-editor-reset' ).click( function()
      {
        var button = $(this);

        //Show loader
        ui.loader.show();
        //Disabled button
        button.addClass( 'disabled' );
        button.attr( 'disabled', 'disabled' );

        var imgsrc = $this.attachment.attributes.sizes.full.url;

        //set width & height
        $this.imageWidth  = $this.attachment.attributes.width;
        $this.imageHeight = $this.attachment.attributes.height;

        //remove image
        if ( $this.fbrImage ) {
          $this.canvas.remove( $this.fbrImage );
          $this.fbrImage = null;
          $( '#camanjs-target' ).remove();
        }

        //reset button
        $( '.ipimpr-editor-tool' ).removeClass( 'disabled' );
        $( '.ipimpr-editor-tool' ).removeAttr( 'disabled' );
        $( '.ipimpr-editor-filter' ).removeClass( 'disabled' );
        $( '.ipimpr-editor-filter' ).removeAttr( 'disabled' );

        fabric.Image.fromURL(imgsrc, function(img)
        {
          $this.fbrImage = img;
          img.set({
            left: 20,
            top: 20,
            height: $this.attachment.attributes.height,
            width: $this.attachment.attributes.width,
            lockRotation: true,
            lockScalingFlip: true,
            lockScalingX: true,
            lockScalingY: true,
            hasBorders: false,
            hasRotatingPoint: false,
            hoverCursor: 'move'
          });

          $this.canvas.add(img).setActiveObject(img);
          $this.canvas.renderAll();

          var hiddenImg = document.createElement('img');
          hiddenImg.src = $this.canvas.getActiveObject().toDataURL();
          hiddenImg.id = 'camanjs-target';
          hiddenImg.style.display = 'none';
          document.body.appendChild(hiddenImg);

          Caman( '#camanjs-target', function()
          {
            this.render();

            //Hide loader
            ui.loader.hide();
          });
          //Undisabled button
          button.removeClass( 'disabled' );
          button.removeAttr( 'disabled' );
        },
        { crossOrigin: 'anonymous' });

        /*
        Caman( '#camanjs-target', function()
        {
          var camanObj = document.getElementById( 'camanjs-target' );

          $( '#ipimpr-editor-filters .ipimpr-editor-filter' ).removeClass( 'disabled' );
          $( '#ipimpr-editor-filters .ipimpr-editor-filter' ).removeAttr( 'disabled' );
          this.revert(false);
          this.render(function()
          {
            $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
              $this.canvas.renderAll();
            });

            //Hide loader
            ui.loader.hide();
            //Undisabled button
            button.removeClass( 'disabled' );
            button.removeAttr( 'disabled' );
          });
        });
        */

        return false;
      });
    },

    //Image filters
    filters: function()
    {
      var $this = this;
      //
      //Main filter
      $( '.ipimpr-editor-filter' ).each( function()
      {
        var button = $(this);
        button.click( function(e)
        {
          e.preventDefault();
          //Show loader
          ui.loader.show();

          var filter = button.data( 'filter' );
          Caman( '#camanjs-target', function()
          {
            var camanObj = document.getElementById( 'camanjs-target' );

            // If such an effect exists, use it:
            if( filter in this)
            {
              this[filter]();
              this.render(function()
              {
                $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
                  $this.canvas.renderAll();
                });

                //Hide loader
                ui.loader.hide();
              });
            }
          });
          return false;
        });
      });

      //
      //Posterize
      $( '.ipimpr-editor-filter-posterize' ).click( function()
      {
        //Show loader
        ui.loader.show();

        Caman( '#camanjs-target', function()
        {
          var camanObj = document.getElementById( 'camanjs-target' );

          this.posterize(8, 8).render();
          this.render(function()
          {
            $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
              $this.canvas.renderAll();
            });

            //Hide loader
            ui.loader.hide();
          });
        });
        return false;
      });

      //
      //HDR
      $( '.ipimpr-editor-filter-hdr' ).click( function()
      {
        //Show loader
        ui.loader.show();

        Caman( '#camanjs-target', function()
        {
          var camanObj = document.getElementById( 'camanjs-target' );

          this.contrast(10);
          this.contrast(10);
          this.jarques();

          this.render(function()
          {
            $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
              $this.canvas.renderAll();
            });

            //Hide loader
            ui.loader.hide();
          });
        });
        return false;
      });

    },

    //Actions
    actions: function()
    {
      var $this = this;

      //Save image
      //
      $( '#ipimpr-editor-save' ).click( function()
      {
        //Show loader
        ui.loader.show();

        var imgid   = $( '#ipimpr-editor-save' ).data( 'id' );
        var canvas  = $this.canvas;
        var objects = canvas.getObjects();
        var image   = objects[0];
        var height  = image.getHeight();
        var width   = image.getWidth();
        var top     = image.getTop();
        var left    = image.getLeft();

        canvas.deactivateAll().renderAll();

        var imgdata = canvas.toDataURL({
          height: height,
          width: width,
          top: top,
          left: left
        });

        $.ajax({
          url: ajaxurl+'?doajax=1&ipimpr=1&action=saveimage',
          type: "POST",
          data: 'imageData=' + imgdata + '&imageId=' + imgid,
          dataType: "json",
          success: function ( result )
          {
            $( '#ipimpr-editor-insert' ).removeClass( 'disabled' );
            $( '#ipimpr-editor-insert' ).removeAttr( 'disabled' );

            //Hide loader
            ui.loader.hide();
            //Show message
            if ( result.status == 1 )
            {
              $( '#ipimpr-editor-insert' ).attr( 'data-id', result.id );
              ui.message.modal( result.message, 'alert-success' );
            } else {
              ui.message.modal( result.message, 'alert-danger' );
            }
          }
        });

        return false;
      });

      //
      //Menu actions
      //
      $( '.ipimpr-editor-actions' ).show();
      $( '.ipimpr-editor-actions ._actions-menu ._action-link' ).click( function()
      {
        $( '.ipimpr-editor-actions ._actions-menu ._action-link' ).removeClass( '_active' );
        $( this ).addClass( '_active' );
        $( '.ipimpr-editor-actions ._action-content' ).hide();
        $( '.ipimpr-editor-actions ._actions-content' ).show();
        $( $(this).attr( 'href' ) ).show();

        //
        //Cropping
        //
        if ( $(this).hasClass( '_action-link-crop' ) )
        {
          Crop.init( $this.canvas, $this.fbrImage );
        }
        else
        {
          // Canvas events
          $this.fbrImage.set({
            top: 0,
            left: 0,
            lockMovementX: false,
            lockMovementY: false,
            hoverCursor: 'move'
          });
          Crop.releaseFocus();
        }
        return false;
      });

      //
      //Add text handler
      //
      CanvasText.init( $this.canvas, $this.fbrImage );

      //
      //Resize image
      //
      $( '#__ipimpr-editor-resize-submit' ).click( function()
      {
        //Show loader
        ui.loader.show();

        var height = $( '#__ipimpr-editor-resize-height' ).val();
        var width  = $( '#__ipimpr-editor-resize-width' ).val();
        var prop   = $( '#__ipimpr-editor-resize-proportions' ).is(":checked");

        var oheight = $this.imageHeight;
        var owidth  = $this.imageWidth;

        if ( height == 0 || height == '' || width == 0 || width == '' )
        {
          ui.alert.show( 'You must enter the height and width of the image' );
          return false;
        }
        if ( prop )
        {
          if ( width != owidth ) {
            var per = width/owidth;
            height  = Math.round( per * oheight );
          }
          else if ( height != oheight ) {
            var per = height/oheight;
            width   = Math.round( per * owidth );
          }
        }
        //set height & width
        $( '#__ipimpr-editor-resize-width' ).val( width );
        $( '#__ipimpr-editor-resize-height' ).val( height );
        $this.imageWidth  = width;
        $this.imageHeight = height;

        Caman( "#camanjs-target", function ()
        {
          this.resize({
            width: width,
            height: height
          });

          this.render(function()
          {
            var camanObj = document.getElementById( 'camanjs-target' );
            $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
              $this.canvas.renderAll();
            });

            //Hide loader
            ui.loader.hide();
          });
        });

        //Hide loader
        ui.loader.hide();

        return false;
      });

      //
      //Coloring
      //
      $( '#__ipimpr-editor-coloring-submit' ).click( function()
      {
        //Show loader
        ui.loader.show();

        var color    = $( '#__ipimpr-editor-coloring-color' ).val();
        var opacity  = $( '#__ipimpr-editor-coloring-opacity' ).val();
        var blending = $( '#__ipimpr-editor-coloring-blending' ).val();

        Caman( "#camanjs-target", function ()
        {
          // Create the layer
          this.newLayer(function ()
          {
            // Change the blending mode
            this.setBlendingMode( blending );

            // Change the opacity of this layer
            this.opacity( opacity );

            // Fill this layer with a solid color...
            this.fillColor( color );
          });

          this.render(function()
          {
            var camanObj = document.getElementById( 'camanjs-target' );
            $this.fbrImage.setSrc( camanObj.toDataURL(), function() {
              $this.canvas.renderAll();
            });

            //Hide loader
            ui.loader.hide();
          });
        });

        return false;
      });
    }
  }

})
(jQuery);

module.exports = ipimprEditor;

},{"./../dest/canvas-text.js":2,"./../dest/crop.js":4,"./../libs/ui.js":8}],6:[function(require,module,exports){
var ui  = require( './../libs/ui.js' );

/*
 *===========================================================
 * Image searcher
 *===========================================================*/
var ipimprSearcher;

(function($)
{
  //Prepare ui
  if (typeof ui_base_image != 'undefined') {
    ui.base.construct.prototype.image_base = ui_base_image;
  }
  ui.base.confirm.prototype.set_ajax = function( ajax_url )
  {
      this.ajax_url = ajax_url;
  };
  ui.init();

  ipimprSearcher =
  {
    //Keyword
    keyword: '',
    loading: false,
    count: 0,
    providerLoaded: 0,
    currentPhoto: {},
    currentPhotoSizes: {},

    //
    //Init
    init: function( keyword )
    {
      this.keyword = keyword;

      //loading
      this.loading = true;
      $( '.ipimpr-search-info ._loader' ).show();

      //
      //Flickr
      //this.flickr();
      //
      //Pixabay
      this.pixabay();
      //
      //Instagram
      //this.instagram();
      //
      //Twitter
      //this.twitter();
      // 
      //Icon FInder
      this.iconfinder();
      //
      //Open clipart
      this.openclipart();
      //
      //Wikimedia
      this.wikimedia();
      //
      //Unsplash
      this.unsplash();
    },

    //
    //Get images from flickr
    flickr: function()
    {
      var $this = this;
      $this.providerLoaded++;

      if ( ! ipimpr_flickr ) {
        return false;
      }
      var kword  = this.keyword;
      var apiKey = ipimpr_flickr_api_key;
      //
      //Get api url
      var apiUrl = 'https://api.flickr.com/services/rest/?api_key=' + apiKey;
      apiUrl += '&method=flickr.photos.search';
      apiUrl += '&text=' + kword;
      apiUrl += '&format=json';
      apiUrl += '&license=7,8,9,10';
      apiUrl += '&privacy_filter=1';
      apiUrl += '&content_type=1';
      apiUrl += '&per_page=80';
      apiUrl += '&jsoncallback=?';

      //
      //Get images
      $.getJSON( apiUrl, function( data )
      {
        if ( data.stat == "ok" )
        {
          //Update data
          $this.count += data.photos.photo.length;

          for (var i=0; i<data.photos.photo.length; i++)
          {
            var photo    = data.photos.photo[i];
            var photoId  = photo.id;
            var photoUrl = $this.getFlickrUrl( photo, 'q' );

            if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
              $( '.ipimpr-search-results ._empty ').remove();
            }

            var img = $this.getHtmlImage( photoUrl, photoId, 'flickr', photo );
          }

          //finis load
          $this.finish( 'flickr' );
        }
        //Show loader
        ui.loader.hide();
      });

    },

    //
    //Get flickr detail image
    flickrDetail: function( photoId )
    {
      if ( ! ipimpr_flickr ) {
        return false;
      }
      var $this  = this;
      var apiKey = ipimpr_flickr_api_key;
      //
      //Get api url
      var apiUrl = 'https://api.flickr.com/services/rest/?api_key=' + apiKey;
      apiUrl += '&method=flickr.photos.getInfo';
      apiUrl += '&photo_id=' + photoId;
      apiUrl += '&format=json';
      apiUrl += '&jsoncallback=?';

      //
      //Get detail image
      var imageDetail = false;
      var imageSize   = false;
      $.getJSON( apiUrl, function( data )
      {
        if ( data.stat == "ok" )
        {
          $this.currentPhoto = data.photo;

          //Reset image info
          $this.resetImageInfo();

          $( '.ipimpr-image-detail ._detail-content' ).show();
          //Set photo
          var photoUrl = $this.getFlickrUrl( data.photo, 'm' );
          $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photoUrl );
          //Set title
          var photoTitle = data.photo.title._content;
          $( '.ipimpr-image-detail ._detail-image-title' ).text( photoTitle );
          $( '.ipimpr-image-detail ._detail-meta-title' ).text( photoTitle );
          $( '.ipimpr-image-detail ._detail-meta-alt' ).text( photoTitle );
          //Set desc
          $( '.ipimpr-image-detail ._detail-meta-desc' ).text( data.photo.description._content );
        }
        //Hide loader
        imageDetail = true;
        if ( imageSize ) {
          ui.loader.hide();
        }
      });

      //
      //Get sizes image
      //
      var apiUrl = 'https://api.flickr.com/services/rest/?api_key=' + apiKey;
      apiUrl += '&method=flickr.photos.getSizes';
      apiUrl += '&photo_id=' + photoId;
      apiUrl += '&format=json';
      apiUrl += '&jsoncallback=?';

      $.getJSON( apiUrl, function( data )
      {
        if ( data.stat == "ok" )
        {
          $this.currentPhotoSizes = data.sizes;

          var width  = 0;
          var height = 0;
          var source = '';

          for (var i=0; i<data.sizes.size.length; i++)
          {
            var size = data.sizes.size[i];
            if ( size.label == 'Original' ) {
              width  = size.width;
              height = size.height;
              source = size.source;
            }
          }
          if ( source == '' ) {
            var len = data.sizes.size.length;
            if ( typeof data.sizes.size[len] != 'undefined' ) {
              source = data.sizes.size[len].source;
            }
          }
          $( '#ipimpr-photo-url-selected' ).val( source );

          //Set size
          var sizeLabel = width + ' x ' + height;
          $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
        }
        //Hide loader
        imageSize = true;
        if ( imageDetail ) {
          ui.loader.hide();
        }
      });
    },

    //
    //Get images from pixabay
    pixabay: function()
    {
      var $this = this;
      $this.providerLoaded++;

      if ( ! ipimpr_pixabay ) {
        return false;
      }
      var kword  = this.keyword;
      var apiKey = ipimpr_pixabay_api_key;
      //
      //Get api url
      var apiUrl = 'https://pixabay.com/api/?key=' + apiKey;
      apiUrl += '&q=' + kword;
      apiUrl += '&per_page=80';
      apiUrl += '&callback=?';

      //
      //Get images
      $.getJSON( apiUrl, function( data )
      {
        if ( data.hits.length > 0 )
        {
          //Update data
          $this.count += data.hits.length;

          for (var i=0; i<data.hits.length; i++)
          {
            var photo    = data.hits[i];
            var photoId  = photo.id;
            var photoUrl = $this.getPixabayUrl( photo, 's' );

            if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
              $( '.ipimpr-search-results ._empty ').remove();
            }

            var img = $this.getHtmlImage( photoUrl, photoId, 'pixabay', photo );
          }

          //finis load
          $this.finish( 'pixabay' );
        }
        //Show loader
        ui.loader.hide();
      });

    },

    //
    //Get pixabay detail image
    pixabayDetail: function( photoId )
    {
      if ( ! ipimpr_pixabay ) {
        return false;
      }
      var $this  = this;
      var apiKey = ipimpr_pixabay_api_key;
      //
      //Get api url
      var apiUrl = 'https://pixabay.com/api/?key=' + apiKey;
      //apiUrl += '&response_group=high_resolution';
      apiUrl += '&id=' + photoId;
      apiUrl += '&callback=?';

      //
      //Get detail image
      $.getJSON( apiUrl, function( data )
      {
        if ( data.hits.length > 0 )
        {
          var photo = data.hits[0];
          $this.currentPhoto = photo;

          //Reset image info
          $this.resetImageInfo();

          $( '.ipimpr-image-detail ._detail-content' ).show();
          //Set photo
          var photoUrl = $this.getPixabayUrl( photo, 's' );
          $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photoUrl );
          //Set title
          var tags = photo.tags;
          $( '.ipimpr-image-detail ._detail-image-title' ).text( tags );
          $( '.ipimpr-image-detail ._detail-meta-title' ).text( tags );
          $( '.ipimpr-image-detail ._detail-meta-alt' ).text( tags );

          //
          //Get high resolution image
          //
          var apiUrl = 'https://pixabay.com/api/?key=' + apiKey;
          apiUrl += '&response_group=high_resolution';
          apiUrl += '&id=' + photoId;
          apiUrl += '&callback=?';

          $.getJSON( apiUrl, function( data )
          {
            if ( data.hits.length > 0 )
            {
              $.extend( $this.currentPhoto, data.hits[0] );
              //Set large photo url
              var largePhotoUrl = $this.getPixabayUrl( data.hits[0], 'l' );
              $( '#ipimpr-photo-url-selected' ).val( largePhotoUrl );

              //Set size
              var sizes     = $this.getPixabaySizes( data.hits[0], 'l' );
              var sizeLabel = sizes.width + ' x ' + sizes.height;
              $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
            }
          });
        }

        //Hide loader
        ui.loader.hide();
      });

    },

    //
    //Get images from twitter
    twitter: function()
    {
      var $this  = this;
      var kword  = this.keyword;

      $this.providerLoaded++;

      //
      //Get images
      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=gettwitter',
        type: "POST",
        data: 'query=' + kword,
        dataType: "json",
        success: function ( data )
        {
          if ( data.status == 1 )
          {
            //Update data
            $this.count += data.photos.length;

            for (var i=0; i<data.photos.length; i++)
            {
              var photo = data.photos[i];
              if ( typeof photo.retweeted_status != 'undefined' && photo.retweeted_status ) {
                var photoId  = photo.retweeted_status.tweet_id;
                var photoUrl = photo.retweeted_status.media_url;
              }
              else {
                var photoId  = photo.tweet_id;
                var photoUrl = photo.media_url;
              }

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }

              var img = $this.getHtmlImage( photoUrl, photoId, 'twitter', photo );
            }

            //finis load
            $this.finish( 'twitter' );
          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get twitter detail image
    twitterDetail: function( photoId )
    {
      var $this = this;

      //
      //Get detail image
      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=gettwitterdetail',
        type: "POST",
        data: 'id=' + photoId,
        dataType: "json",
        success: function ( data )
        {
          if ( data.status == 1 )
          {
            var photo = data.photo;
            $this.currentPhoto = photo;

            //Reset image info
            $this.resetImageInfo();

            $( '.ipimpr-image-detail ._detail-content' ).show();
            //Set photo
            $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photo.media_url );
            //Set title
            var title = photo.title;
            $( '.ipimpr-image-detail ._detail-image-title' ).text( title );
            $( '.ipimpr-image-detail ._detail-meta-title' ).text( title );
            $( '.ipimpr-image-detail ._detail-meta-alt' ).text( title );

            //Set large photo url
            $( '#ipimpr-photo-url-selected' ).val( photo.media_url );

            //Set size
            var sizeLabel = photo.sizes.large.w + ' x ' + photo.sizes.large.h;
            $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
          }

          //Hide loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get images from instagram
    instagram: function()
    {
      var $this  = this;
      var kword  = this.keyword;

      $this.providerLoaded++;

      //
      //Get images
      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=getinstagram',
        type: "POST",
        data: 'query=' + kword,
        dataType: "json",
        success: function ( result )
        {
          if ( result.status == 1 )
          {
            //Update data
            $this.count += result.photos.length;

            for (var i=0; i<result.photos.length; i++)
            {
              var photo    = result.photos[i];
              var photoId  = photo.id;
              var photoUrl = photo.images.thumbnail.url;

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }

              var img = $this.getHtmlImage( photoUrl, photoId, 'instagram', photo );
            }

            //finis load
            $this.finish( 'instagram' );
          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get instagram detail image
    instagramDetail: function( photoId )
    {
      var $this  = this;

      //
      //Get detail image
      $.ajax({
        url: ajaxurl+'?doajax=1&ipimpr=1&action=getinstagramdetail',
        type: "POST",
        data: 'id=' + photoId,
        dataType: "json",
        success: function ( result )
        {
          if ( result.status == 1 )
          {
            $this.currentPhoto = result.photo;

            //Reset image info
            $this.resetImageInfo();

            $( '.ipimpr-image-detail ._detail-content' ).show();
            //Set photo
            var photoUrl = result.photo.images.thumbnail.url;
            $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photoUrl );
            //Set description
            if ( typeof result.photo.caption.text != 'undefined' )
            {
              $( '.ipimpr-image-detail ._detail-meta-desc' ).text( result.photo.caption.text );
            }
            //set original image
            var source = result.photo.images.standard_resolution.url;
            $( '#ipimpr-photo-url-selected' ).val( source );

            //Set size
            var width  = result.photo.images.standard_resolution.width;
            var height = result.photo.images.standard_resolution.height;
            var sizeLabel = width + ' x ' + height;
            $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );

          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get images from icon finder
    iconfinder: function()
    {
      var $this  = this;
      var kword  = this.keyword;

      $this.providerLoaded++;
      //
      //Get api url
      var apiUrl = 'https://api.iconfinder.com/v2/icons/search';
      apiUrl += '?query=' + kword;
      apiUrl += '&premium=0';
      apiUrl += '&vector=0';
      apiUrl += '&license=commercial-nonattribution';
      apiUrl += '&count=80';

      //
      //Get images
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data.total_count > 0 )
          {
            //Update data
            $this.count += data.icons.length;

            for (var i=0; i<data.icons.length; i++)
            {
              var photo    = data.icons[i];
              var photoId  = photo.icon_id;
              var photoUrl = $this.getIconfinderUrl( photo, 's' );

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }

              var img = $this.getHtmlImage( photoUrl, photoId, 'iconfinder', photo );
            }

            //finis load
            $this.finish( 'iconfinder' );
          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get iconfinder detail image
    iconfinderDetail: function( photoId )
    {
      var $this = this;

      //
      //Get api url
      var apiUrl = 'https://api.iconfinder.com/v2/icons/' + photoId;

      //
      //Get detail image
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data )
          {
            $this.currentPhoto = data;

            //Reset image info
            $this.resetImageInfo();

            $( '.ipimpr-image-detail ._detail-content' ).show();
            //Set photo
            var photoUrl = $this.getIconfinderUrl( data, 's' );
            $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photoUrl );
            //Set large image
            var source = $this.getIconfinderUrl( data, 'l' );
            $( '#ipimpr-photo-url-selected' ).val( source );

            //Set size
            var sizes = $this.getIconfinderSizes( data, 'l' );
            var sizeLabel = sizes.width + ' x ' + sizes.height;
            $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
          }
          //Hide loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get images from open clipart
    openclipart: function()
    {
      var $this  = this;
      var kword  = this.keyword;

      $this.providerLoaded++;
      //
      //Get api url
      var apiUrl = 'https://openclipart.org/search/json/';
      apiUrl += '?query=' + kword;
      apiUrl += '&amount=80';

      //
      //Get images
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data.msg == "success" )
          {
            //Update data
            $this.count += data.payload.length;

            for (var i=0; i<data.payload.length; i++)
            {
              var photo    = data.payload[i];
              var photoId  = photo.id;
              var photoUrl = photo.svg.png_thumb;

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }

              var img = $this.getHtmlImage( photoUrl, photoId, 'openclipart', photo );
            }

            //finis load
            $this.finish( 'openclipart' );
          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get open clipart detail image
    openclipartDetail: function( photoId )
    {
      var $this = this;

      //
      //Get api url
      var apiUrl = 'https://openclipart.org/search/json/';
      apiUrl += '?byids=' + photoId;

      //
      //Get detail image
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data.msg == "success" )
          {
            $this.currentPhoto = data.payload[0];
            var photo = data.payload[0];

            //Reset image info
            $this.resetImageInfo();

            $( '.ipimpr-image-detail ._detail-content' ).show();
            //Set photo
            $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photo.svg.png_thumb );
            //Set title
            $( '.ipimpr-image-detail ._detail-image-title' ).text( photo.title );
            $( '.ipimpr-image-detail ._detail-meta-title' ).text( photo.title );
            $( '.ipimpr-image-detail ._detail-meta-alt' ).text( photo.title );
            //Set desc
            $( '.ipimpr-image-detail ._detail-meta-desc' ).text( photo.description );

            //Set large image
            $( '#ipimpr-photo-url-selected' ).val( photo.svg.png_full_lossy );

            //Set size
            var sizes = photo.dimensions.png_full_lossy;
            var sizeLabel = sizes.width + ' x ' + sizes.height;
            $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
          }
          //Hide loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get images from wikimedia
    wikimedia_results: [],

    wikimedia: function()
    {
      var $this  = this;
      var kword  = this.keyword;

      $this.providerLoaded++;

      //
      //Get api url
      var apiUrl = 'https://commons.wikimedia.org/w/api.php?action=query';
      apiUrl += '&aifrom=' + kword;
      apiUrl += '&list=allimages';
      apiUrl += '&ailimit=80';
      apiUrl += '&aiprop=dimensions%7Curl';
      apiUrl += '&format=json';
      apiUrl += '&callback=?';

      //
      //Get images
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        headers: { 'Api-User-Agent': 'Example/1.0' },
        success: function ( data )
        {
          if ( data.query.allimages )
          {
            //Update data
            $this.count += data.query.allimages.length;

            for (var i=0; i<data.query.allimages.length; i++)
            {
              var photo    = data.query.allimages[i];
              var photoId  = i;
              var photoUrl = photo.url;

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }
              var img = $this.getHtmlImage( photoUrl, photoId, 'wikimedia', photo );

              $this.wikimedia_results[i] = photo;
            }

            //finis load
            $this.finish( 'wikimedia' );
          }
          //Show loader
          ui.loader.hide();
        }
      });
    },

    //
    //Get wikimedia detail image
    wikimediaDetail: function( photoId )
    {
      var $this = this;

      //Reset image info
      $this.resetImageInfo();

      if ( typeof $this.wikimedia_results[photoId] != "undefined" )
      {
        $this.currentPhoto = $this.wikimedia_results[photoId];
        var photo = $this.wikimedia_results[photoId];

        $( '.ipimpr-image-detail ._detail-content' ).show();
        //Set photo
        $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photo.url );
        //Set title
        $( '.ipimpr-image-detail ._detail-image-title' ).text( photo.title );
        $( '.ipimpr-image-detail ._detail-meta-title' ).text( photo.title );
        $( '.ipimpr-image-detail ._detail-meta-alt' ).text( photo.title );

        //Set large image
        $( '#ipimpr-photo-url-selected' ).val( photo.url );

        //Set size
        var sizeLabel = photo.width + ' x ' + photo.height;
        var sizeLabel = photo.width + ' x ' + photo.height;
        $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
      }
      //Hide loader
      ui.loader.hide();
    },

    //
    //Get images from unsplash
    unsplash: function()
    {
      var $this = this;
      $this.providerLoaded++;

      if ( ! ipimpr_unsplash ) {
        return false;
      }
      var kword = this.keyword;
      var appId = ipimpr_unsplash_app_id;
      //
      //Get api url
      var apiUrl = 'https://api.unsplash.com/photos/search/?';
      apiUrl += 'client_id=' + appId;
      apiUrl += '&query=' + kword;
      apiUrl += '&per_page=80';

      //
      //Get images
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data && data.length > 0 )
          {
            //Update data
            $this.count += data.length;

            for (var i=0; i<data.length; i++)
            {
              var photo    = data[i];
              var photoId  = photo.id;
              var photoUrl = $this.getUnsplashUrl( photo, 's' );

              if ( $( '.ipimpr-search-results ._empty ').length > 0 ) {
                $( '.ipimpr-search-results ._empty ').remove();
              }

              var img = $this.getHtmlImage( photoUrl, photoId, 'unsplash', photo );
            }

            //finis load
            $this.finish( 'unsplash' );
          }
          //Show loader
          ui.loader.hide();
        }
      });

    },

    //
    //Get unsplash detail image
    unsplashDetail: function( photoId )
    {
      if ( ! ipimpr_unsplash ) {
        return false;
      }
      var $this  = this;
      var appId  = ipimpr_unsplash_app_id;
      //
      //Get api url
      var apiUrl = 'https://api.unsplash.com/photos/' + photoId + '/';
      apiUrl += '?client_id=' + appId;

      //
      //Get detail image
      $.ajax({
        url: apiUrl,
        type: "GET",
        data: '',
        dataType: "json",
        success: function ( data )
        {
          if ( data )
          {
            var photo = data;
            $this.currentPhoto = photo;

            //Reset image info
            $this.resetImageInfo();

            $( '.ipimpr-image-detail ._detail-content' ).show();
            //Set photo
            var photoUrl = $this.getUnsplashUrl( photo, 's' );
            $( '.ipimpr-image-detail ._detail-image-file' ).attr( 'src', photoUrl );

            //Set large photo url
            var largePhotoUrl = $this.getUnsplashUrl( photo, 'l' );
            $( '#ipimpr-photo-url-selected' ).val( largePhotoUrl );

            //Set size
            var sizeLabel = photo.width + ' x ' + photo.height;
            $( '.ipimpr-image-detail ._detail-image-size' ).text( sizeLabel );
          }

          //Hide loader
          ui.loader.hide();
        }
      });

    },

    //
    //Helpers
    //

    //getFlickrUrl
    getFlickrUrl: function( photo, size )
    {
      var url = 'https://farm';
      url += photo.farm;
      url += '.staticflickr.com/' + photo.server;
      url += '/' + photo.id;
      url += '_' + photo.secret;
      url += '_' + size;
      url += '.jpg';

      return url;
    },

    //getUnsplashUrl
    getUnsplashUrl: function( photo, size )
    {
      var url = '';

      if ( size == 's' ) {
        url = photo.urls.thumb;
      }
      else
      {
        url = photo.urls.full;
      }
      var r = /\\u([\d\w]{4})/gi;
      url   = url.replace(r, function (match, grp) {
            return String.fromCharCode(parseInt(grp, 16));
          });

      return url;
    },

    //getPixabayUrl
    getPixabayUrl: function( photo, size )
    {
      var url = '';

      if ( size == 's' ) {
        url = photo.previewURL;
      }
      else
      {
        if ( typeof photo.imageURL != 'undefined' ) {
          url = photo.imageURL;
        }
        else if ( typeof photo.fullHDURL != 'undefined' ) {
          url = photo.fullHDURL;
        }
        else if ( typeof photo.largeImageURL != 'undefined' ) {
          url = photo.largeImageURL;
        }
        else if ( typeof photo.webformatURL != 'undefined' ) {
          url = photo.webformatURL;
        }
      }
      return url;
    },

    //getPixabaySizes
    getPixabaySizes: function( photo, size )
    {
      var width  = 0;
      var height = 0;

      if ( size == 's' ) {
        width  = photo.previewWidth;
        height = photo.previewHeight;
      }
      else
      {
        if ( typeof photo.imageURL != 'undefined' ) {
          width  = photo.imageWidth;
          height = photo.imageHeight;
        }
        else if ( typeof photo.fullHDURL != 'undefined' ) {
          width  = photo.imageWidth;
          height = photo.imageHeight;
        }
        else if ( typeof photo.largeImageURL != 'undefined' ) {
          width  = photo.imageWidth;
          height = photo.imageHeight;
        }
        else if ( typeof photo.webformatURL != 'undefined' ) {
          width  = photo.webformatWidth;
          height = photo.webformatHeight;
        }
      }
      return {
        'width': width,
        'height': height
      };
    },

    //getIconfinderUrl
    getIconfinderUrl: function( photo, size )
    {
      var url   = '';
      var sizes = photo.raster_sizes;
      var last  = sizes.length - 1;
      var small = false;

      if ( size == 's' )
      {
        for (var i=0; i<sizes.length; i++)
        {
          var current = sizes[i];
          if ( current.size == 128 ) {
            small = current;
            url   = current.formats[0].preview_url;
          }
        }
        if ( ! small ) {
          url = sizes[last].formats[0].preview_url;
        }
      }
      else {
        url = sizes[last].formats[0].preview_url;
      }
      return url;
    },

    //getIconfinderSizes
    getIconfinderSizes: function( photo, size )
    {
      var sizes  = photo.raster_sizes;
      var last   = sizes.length - 1;
      var width  = sizes[last].size_width;
      var height = sizes[last].size_height;

      return {
        'width': width,
        'height': height
      };
    },

    //getHtmlImage
    getHtmlImage: function( photoUrl, photoId, type, photo )
    {
      var cimg = $( '<div class="_image _image-' + type + '"></div>' );
      var aimg = $( '<a href="#" class="_image-link" data-id="' + photoId + '" data-type="' + type + '"></a>' );
      var img  = $( '<img src="' + photoUrl + '" alt="" />' );
      this.imageAction( aimg );

      $( '.ipimpr-search-results ._images' ).append( cimg.append( aimg.append( img )));
    },

    //imageAction
    imageAction: function( object )
    {
      var $this = this;

      object.click( function()
      {
        $( '.ipimpr-search-results-main ._image-link' ).removeClass( '_selected' );
        $(this).addClass( '_selected' );

        var type = $(this).data( 'type' );
        var id   = $(this).data( 'id' );

        //
        //Set value
        $( '#ipimpr-photo-id-selected' ).val( id );
        $( '#ipimpr-photo-type-selected' ).val( type );

        //
        //Show loader
        ui.loader.show();

        //
        //Reset submit button
        $( '#ipimpr-search-insert' ).removeClass( 'disabled' ).removeAttr( 'disabled' );
        $( '#ipimpr-search-save' ).removeClass( 'disabled' ).removeAttr( 'disabled' );

        //
        //Get photo info
        if ( type == 'flickr' )
        {
          $this.flickrDetail( id );
        }
        else if ( type == 'pixabay' )
        {
          $this.pixabayDetail( id );
        }
        else if ( type == 'instagram' )
        {
          $this.instagramDetail( id );
        }
        else if ( type == 'twitter' )
        {
          $this.twitterDetail( id );
        }
        else if ( type == 'iconfinder' )
        {
          $this.iconfinderDetail( id );
        }
        else if ( type == 'openclipart' )
        {
          $this.openclipartDetail( id );
        }
        else if ( type == 'wikimedia' )
        {
          $this.wikimediaDetail( id );
        }
        else if ( type == 'unsplash' )
        {
          $this.unsplashDetail( id );
        }

        return false;
      });
    },

    //finish
    finish: function( type )
    {
      if ( this.providerLoaded >= 8 )
      {
        $( '.ipimpr-search-info ._loader' ).hide();
        $( '.ipimpr-search-info ._result' ).show();
        $( '.ipimpr-search-info ._result ._count' ).text( this.count );
        //
        //Reset input search
        $( '#ipimpr-search-keyword-input' ).removeClass( '_disabled' ).removeAttr( 'disabled' );
        $( '#ipimpr-search-keyword-button' ).removeClass( '_disabled' ).removeAttr( 'disabled' );
      }

      if ( this.providerLoaded > 0 )
      {
        $( '.ipimpr-search-actions .ipimpr-search-filter' ).show();

        var select = $( '.ipimpr-search-actions #ipimpr-provider-input' );
        var count  = $( '.ipimpr-search-results ._image-' + type ).length;

        if ( count > 0 )
        {
          if ( type == 'flickr' ) {
            select.append( '<option value="flickr">Flickr (' + count + ')</option>')
          }
          else if ( type == 'pixabay' ) {
            select.append( '<option value="pixabay">Pixabay (' + count + ')</option>')
          }
          else if ( type == 'instagram' ) {
            select.append( '<option value="instagram">Instagram (' + count + ')</option>')
          }
          else if ( type == 'twitter' ) {
            select.append( '<option value="twitter">Twitter (' + count + ')</option>')
          }
          else if ( type == 'iconfinder' ) {
            select.append( '<option value="iconfinder">Iconfinder (' + count + ')</option>')
          }
          else if ( type == 'openclipart' ) {
            select.append( '<option value="openclipart">Openclipart (' + count + ')</option>')
          }
          else if ( type == 'wikimedia' ) {
            select.append( '<option value="wikimedia">Wikimedia Commons (' + count + ')</option>')
          }
          else if ( type == 'unsplash' ) {
            select.append( '<option value="unsplash">Unsplash (' + count + ')</option>')
          }
        }
      }
    },

    //Reset image info
    resetImageInfo: function()
    {
      $( '.ipimpr-image-detail ._detail-image-title' ).text( '-' );
      $( '.ipimpr-image-detail ._detail-meta-title' ).text( '-' );
      $( '.ipimpr-image-detail ._detail-meta-alt' ).text( '-' );
      $( '.ipimpr-image-detail ._detail-meta-caption' ).text( '-' );
      //Set desc
      $( '.ipimpr-image-detail ._detail-meta-desc' ).text( '-' );
    }
  };
})
(jQuery);

module.exports = ipimprSearcher;

},{"./../libs/ui.js":8}],7:[function(require,module,exports){
/*
 *===========================================================
 * Form Handler
 *===========================================================
 */
 var formHandler;
 var uifunc = require( './../libs/ui.js' );

(function($)
{
    "use strict";

    //Prepare ui
    if (typeof ui_base_image != 'undefined') {
        uifunc.base.construct.prototype.image_base = ui_base_image;
    }
    uifunc.base.confirm.prototype.set_ajax = function( ajax_url )
    {
        this.ajax_url = ajax_url;
    };

    /**
     * Form handler
     */
    function ip_form( id ){
        this.form   = $( id );
        this.action = this.form.attr( 'action' );
    }
    //Set vars
    ip_form.prototype =
    {
        //Variables
        button_id:          '.ipimpr-form-submit',
        cont_id:            '.ipimpr-form-container',
        error_process:      'Error',
        success_process:    'Success',
        ajax_type:          'POST',
        ajax_dataType:      'json',

        afterSuccess:        function(){},

        //Init
        init: function()
        {
            var $this = this;
            //Prepare
            this.prepare();
            //Form submit
            $( this.button_id, $this.form ).click( function()
            {
                if ( $this.validator() ) {
                    if ( $this.before() ) {
                        uifunc.loader.show();
                        var data   = $this.get_data();
                        var result = $this.process();
                        $this.after( result );
                    }
                }
                $this.error();
                return false;
            });
        },
        //Prepare form
        prepare: function(){},
        //Main process
        process: function()
        {
            var $this = this;
            var data  = $this.get_data();
            $.ajax({
                url: $this.action,
                type: $this.ajax_type,
                dataType: $this.ajax_dataType,
                data: data,
                success: function( result ) {
                    $this.ajax_success( result, $this );
                },
                error: function() {
                    $this.ajax_error( $this );
                }
            });
        },
        //Before process
        before: function()
        {
            return true;
        },
        //After process
        after: function( result ){},
        //Process if error
        error: function(){},
        //Process if ajax success
        ajax_success: function( result, $this )
        {
            $( '.ui-message', $this.form ).remove();
            uifunc.loader.hide();
            if ( result.status == 1 ) {
                if ( typeof result.redirect != 'undefined' ) {
                    window.location.href = result.redirect;
                } else {
                    if ( typeof result.reset != 'undefined' ) {
                        $this.form[0].reset();
                    }
                    uifunc.message.modal( result.message, 'alert-success' );
                    this.afterSuccess( result, $this );
                }
            } else {
                uifunc.message.modal( result.message, 'alert-danger' );
            }
        },
        //Process if ajax error
        ajax_error: function( $this )
        {
            uifunc.loader.hide();
            uifunc.message.modal( $this.error_process, 'alert-danger' );
        },

        //Validating form data
        validator: function()
        {
            return true;
        },
        check_empty: function( id, message )
        {
            var input = $( id );
            if ( input.val() == '' ) {
                uifunc.message.block( message, 'ip-ui-danger', input );
                return true;
            }
            return false;
        },

        //Get data form
        get_data: function()
        {
            var root = this.form;
            var selector  = 'input[type=text]';
            selector += ', input[type=hidden]';
            selector += ', input[type=password]';
            selector += ', input[type=radio]:checked';
            selector += ', input[type=checkbox]:checked';
            selector += ', textarea';
            selector += ', select';

            var data = '';
            $( selector, root ).each( function(){
                var name  = $(this).attr( 'name' );
                var value = encodeURIComponent( $(this).val() );

                if ( data != '' ) {
                    data += '&';
                }
                data += name+'='+value;
            });
            if (typeof tinyMCE !== 'undefined') {
                for ( var edId in tinyMCE.editors ) {

                    if ( edId.length > 1 ) {
                        var value = tinyMCE.editors[edId].getContent();
                        if ( data != '' ) {
                            data += '&';
                        }
                        data += edId+'='+value;
                    }
                }
            }
            data = this.additional_data( data );
            return data;
        },
        additional_data: function( data )
        {
            return data;
        },

        //Get tiny mce object
        get_tinymce: function( contentId )
        {
            var content = '';
            if (typeof tinyMCE !== 'undefined') {
                content = tinyMCE.get( contentId ).getContent();
            }
            return content;
        },
        //Set tiny mce object with a content
        set_tinymce: function( contentId, content )
        {
            if (typeof tinyMCE !== 'undefined') {
                tinyMCE.get( contentId ).setContent( content );
            }
        }
    };
    formHandler = ip_form;

})(jQuery);

module.exports = formHandler;

},{"./../libs/ui.js":8}],8:[function(require,module,exports){
/*
 *===========================================================
 * UI
 *===========================================================
 */
var ui;

(function($)
{
    "use strict";

    //Inherit function
    function inherit( proto )
    {
        function F() {}
        F.prototype = proto
        return new F
    }

    /*
     *===========================================================
     * Ui prototype
     *===========================================================*/
    function ui_construct( options ){};

    ui_construct.prototype =
    {

        vars:               {},
        class_prefix:       'ipimpr-',
        class_main:         '-main',
        class_title:        '-title',
        class_content:      '-content',
        class_disabled:     'disabled',
        class_close:        'ui-close',
        label_close:        'x',
        image_base:         '',

        top_margin:         '80px',
        overlay_speed:      600,
        main_speed:         400,
        show_speed:         4000,

        show_after:         function(){},
        hide_after:         function(){},

        popup_body: function( class_root, content, title, close )
        {
            var body = $( '<div class="'+class_root+'"></div>' );
            var main = $( '<div class="'+class_root + this.class_main+'"></div>' );
            if ( title )
            {
                var _title = $( '<div class="'+class_root + this.class_title+'"></div>' )
                                .append( '<h3>'+title+'</h3>' );
                if ( close )
                {
                    var _close = $( '<a href="#">'+this.label_close+'</a>' );
                    this.popup_close( _close, class_root );

                    _title.append(
                        $( '<div class="'+this.class_prefix+this.class_close+'"></div>' ).append( _close )
                    );
                }
                main.append( _title );
            }
            if ( content ) {
                main.append(
                    $( '<div class="'+class_root + this.class_content+'"></div>' ).append( content )
                );
            }
            body.append( main );
            return body;
        },
        popup_show: function( popup )
        {
            var c_root = popup.attr( 'class' );
            var main   = $( '.'+c_root+this.class_main, popup );
            popup.show();
            main.css( 'margin-top', '-40%' )
                .animate({marginTop: this.top_margin}, this.main_speed, this.show_after);
        },
        popup_hide: function( popup )
        {
            var c_root = popup.attr( 'class' );
            var main   = $( '.'+c_root+this.class_main, popup );

            popup.animate( {opacity: 0}, this.overlay_speed, function(){
                $(this).css( 'opacity', 1 )
                       .hide();
            });
            main.animate( {marginTop: '-60%'}, this.main_speed, this.hide_after);
        },
        popup_close: function( button, class_popup )
        {
            var ui = this;
            button.click( function(){
                var popup = $( '.'+class_popup );
                ui.popup_hide( popup );
                return false;
            });
        },
        is_load: function( selector )
        {
            if ( $( selector ).length > 0 ) {
                return true;
            }
            return false;
        },
        set_vars: function( options )
        {
            this.vars = $.extend(this.vars, options);
        },
        set_base_vars: function( options )
        {
            this.vars = $.extend(this, options);
        },
        go_to: function( selector )
        {
            var pos = $( selector ).position();
            $('html, body').animate({scrollTop: ( pos.top )}, 600);
            return false;
        }
    };

    /*
     * Modal Class
     **/
    function modal(){};
    modal.prototype = inherit( ui_construct.prototype );
    //Modal message
    modal.prototype.ajax = function( id, url )
    {
        var ui      = this;
        var c_root  = this.class_prefix + this.class_modal;
        var modal   = this.popup_body( c_root, '', false, false ).appendTo( $( 'body' ) );
        modal.addClass( class_type )
             .attr( 'id', id );

        this.popup_show( modal );
    };

    /*
     * Loader Class
     **/
    function loader(){};
    loader.prototype = inherit( ui_construct.prototype );
    //Properties
    loader.prototype.class_root     = 'ui-loader';
    loader.prototype.loader_file    = 'loading.gif';
    //Show loader
    loader.prototype.show = function()
    {
        var loader = this.create();
        this.popup_show( loader );
    };
    //Hide loader
    loader.prototype.hide = function()
    {
        var loader = this.create();
        this.popup_hide( loader );
    };
    //Create loader
    loader.prototype.create = function()
    {
        var c_root = this.class_prefix + this.class_root;
        if ( this.is_load( '.'+c_root )) {
            return $( '.'+c_root );
        } else
        {
            var image  = '<img src="'+this.image_base+this.loader_file+'" alt="Loading...">';
            var loader = this.popup_body( c_root, image, false, false ).appendTo( $( 'body' ) );
            loader.hide();

            return loader;
        }
    };


    /*
     * Inline loader Class
     **/
    function iloader(){};
    iloader.prototype = inherit( ui_construct.prototype );
    //Properties
    iloader.prototype.class_root   = 'ui-inline-loader';
    iloader.prototype.loader_file  = 'spin.gif';
    //Loader show
    iloader.prototype.show = function( button )
    {
        button.attr( 'disabled', 'disabled' );
        this.create( button ).show();
    };
    //Loader hide
    iloader.prototype.hide = function( button )
    {
        button.removeAttr( 'disabled' );
        this.create( button ).hide();
    };
    //Creating loader
    iloader.prototype.create = function( button )
    {
        var root   = button.parent();
        var lclass = this.class_prefix + this.class_root;
        if ( $( '.'+lclass, root ).length > 0 ) {
            var loader = $( '.'+lclass, root );
        } else {
            var image  = '<img src="'+this.image_base+this.loader_file+'" alt="Loading...">';
            var loader = $( '<span class="'+lclass+'"></span>' )
                            .append( image )
                            .css( 'margin-left', '8px' );
        }
        button.after( loader );
        return loader;
    };


    /*
     * Confirm popup
     **/
    function confirm( options )
    {
        var defaults = {
            title:      'Confirmation',
            info:       '',
            yes_label:  'Yes',
            no_label:   'Cancel',
            yes_class:  'btn btn-danger',
            no_class:   'btn btn-success',
            action:     function( object ){}
        };
        this.vars = $.extend(defaults, options);
    };
    confirm.prototype = inherit( ui_construct.prototype );
    //Properties
    confirm.prototype.class_root = 'ui-confirm';
    //Confirm show
    confirm.prototype.show = function( object )
    {
        var confirm = this.create( object );
        this.popup_show( confirm );
    };
    //Confirm hide
    confirm.prototype.hide = function( object )
    {
        var confirm = this.create( object );
        this.popup_hide( confirm );
    };
    //Creating confirm
    confirm.prototype.create = function( object )
    {
        var ui     = this;
        var c_root = this.class_prefix + this.class_root;
        if ( this.is_load( '.'+c_root )) {
            $( '.'+c_root ).remove();
        }
        //Create confirm
        var yesbtn = $( '<a href="#" class="ip-confirm-yes '+this.vars.yes_class+'">'+this.vars.yes_label+'</a>' );
        var nobtn  = $( '<a href="#" class="ip-confirm-no '+this.vars.no_class+'">'+this.vars.no_label+'</a>' );

        yesbtn.click( function(){
            ui.vars.action( object, ui );
            return false;
        });
        this.popup_close( nobtn, c_root );

        var content = $( '<div class="'+c_root+'-inner"></div>' )
            .append( '<p>'+this.vars.info+'</p>' )
            .append(
                $( '<div class="'+c_root+'-actions"></div>' )
                    .append( yesbtn )
                    .append( nobtn )
            );

        var confirm = this.popup_body( c_root, content, this.vars.title, false ).appendTo( $( 'body' ) );
        confirm.hide();

        return confirm;
    };


    /*
     * Alert popup
     **/
    function alert( options )
    {
        var defaults = {
            message:        '',
            label_button:   'Ok',
            class_root:     '',
            class_button:   'ipimpr-btn ipimpr-btn-sm ipimpr-btn-danger',
            after:          function(){}
        };
        this.vars = $.extend(defaults, options);
    };
    alert.prototype = inherit( ui_construct.prototype );
    //Properties
    alert.prototype.class_root = 'ui-alert';
    //Alert show
    alert.prototype.show = function( message )
    {
        this.vars.message = message;
        var alert = this.create();
        this.popup_show( alert );
    };
    //Alert hide
    alert.prototype.hide = function()
    {
        var alert = this.create();
        this.hide_after = this.vars.after;
        this.popup_hide( alert );
    };
    //Creating alert
    alert.prototype.create = function()
    {
        var ui     = this;
        var c_root = this.class_prefix + this.class_root;
        if ( this.is_load( '.'+c_root )) {
            return $( '.'+c_root );
        } else
        {
            var button = $( '<a href="#" class="'+this.vars.class_button+'">'+this.vars.label_button+'</a>' );
            this.popup_close( button, c_root );

            var c_info  = c_root + '-inner';
            if ( this.vars.class_root != '' ) {
                c_info += ' ' + this.vars.class_root;
            }
            var content = $( '<div class="'+c_info+'"></div>' )
                .append( '<p>'+this.vars.message+'</p>' )
                .append(
                    $( '<div class="'+c_root+'-actions"></div>' )
                        .append( button )
                );

            var popup  = this.popup_body( c_root, content, false, false ).appendTo( $( 'body' ) );
            popup.hide();

            return popup;
        }
    };


    /*
     * Message
     **/
    function message(){};
    message.prototype = inherit( ui_construct.prototype );
    //Properties
    message.prototype.class_modal = 'ui-modal-message';
    message.prototype.class_block = 'ui-message';
    //Modal message
    message.prototype.modal = function( message, class_type )
    {
        var ui      = this;
        var c_root  = this.class_prefix + this.class_modal;
        var content = '<p>'+message+'</p>';
        var msg     = this.popup_body( c_root, content, false, false ).appendTo( $( 'body' ) );
        msg.addClass( class_type )
           .show()
           .animate({top: "0"}, ui.overlay_speed, function(){
                var object = $( this );
                setTimeout( function(){
                    object.animate({top: '-100px'}, ui.overlay_speed, function(){
                        object.remove();
                    });
                }, ui.show_speed);
            });
    };
    //Bloack message
    message.prototype.block = function( message, class_type, block, close )
    {
        var ui      = this;
        var c_root  = this.class_prefix + this.class_block;
        var parent  = block.parent();

        $( '.'+c_root, parent ).remove();

        var msg = $( '<div></div>' );
        msg.addClass( c_root )
           .addClass( class_type )
           .append( '<p>'+message+'</p>' );

        if ( close )
        {
            var _close = $( '<a href="#">'+this.close_label+'</a>' );
            _close.click( function()
            {
                var _msg = $(this).parents( '.'+c_root );
                _msg.animate({opacity: "0"}, ui.overlay_speed, function(){
                    _msg.remove();
                });
                return false;
            });
            msg.append(
                $( '<div class="'+this.class_prefix+this.class_close+'"></div>' ).append( _close )
            );
        }
        msg.css( 'opacity', '0' );
        parent.prepend( msg );
        msg.animate({opacity: "1"}, ui.overlay_speed);
    };

    ui =
    {
        base: {
            construct:  ui_construct,
            loader:     loader,
            iloader:    iloader,
            confirm:    confirm,
            message:    message,
            alert:      alert,
            modal:      modal

        },
        init: function()
        {
            this.loader  = new this.base.loader(),
            this.iloader = new this.base.iloader(),
            this.confirm = new this.base.confirm(),
            this.message = new this.base.message(),
            this.alert   = new this.base.alert(),
            this.modal   = new this.base.modal()
        }
    };

})(jQuery);

module.exports = ui;

},{}]},{},[1]);
