<?php
if ( ! class_exists( 'IPImpr_Viewer' ))
{
  /**
   * Viewer class
   *
   * @package wp-image-plus
   * @author InstaProduct
   * @link http://insta-product.com/
   */

  class IPImpr_Viewer
  {
    //{{ dashboard

    /**
     * Media frame viewer
     *
     * @return void
     */
    public function media()
    {
      //Render view
      $this->view( 'media/main' );
    }

    //}}}
    //{{{ setting

    /**
     * Admin setting viewer
     *
     * @return string
     */
    public function setting()
    {
      $this->pageId = IPIMPR_PAGENAME . '-setting';
      //Render view
      $this->view( 'setting' );
    }

    //}}
    //{{ view

    /**
     * Get admin view file
     *
     * @param string $filename
     * @return void
     */
    public function view( $filename )
    {
      $path  = IPIMPR_VIEW;
      $path .= strtolower( $filename ) . '.php';
      if ( file_exists( $path )) {
        include( $path );
      }
    }

    //}}
  }
}
